// PatternRecognition.cpp : Defines the entry point for the console application.
//

//#include "iostream.h" // ͷļ
//#include "mclmcr.h" // mxArray 
#include "libdwt.h" // DLL ͷļ
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <sstream>
#include <list>
#include <iostream>
#include <fstream>
#include <map>
#include "math.h"
#include "ADOConn.h"
#include "common.h"
#include "curl/curl.h"
#include <regex>
using namespace std;

//#import "msxml6.dll"
//using namespace MSXML2;
 
#import "msxml4.dll"
#import "C:/Program Files/Common Files/MSSoap/Binaries/mssoap30.dll" exclude("IStream", "IErrorInfo", "ISequentialStream", "_LARGE_INTEGER", "_ULARGE_INTEGER", "tagSTATSTG", "_FILETIME")
using namespace MSSOAPLib30;

int main(int argc, char* argv[])
{
	if (argc > 1 && 0 == strcmp("JOBID", argv[1]))
	{
		char* jobid = argv[2];
		WebSequencesIterate(jobid, "WEB_SEQS");
		return 1;
	}
	if (argc <= 1) 
	{
		int start = 0;
		int end = 0;
		cout << "Start:";
		cin >> start;
		cout << "End:";
		cin >> end;

		//PrtcSequencesIterate(start, end, "PRTC1_SEQS");
		CoreSequencesIterate(start, end, "CORE_SEQS");

		// Import data in database
		//ADOConn conn;
		//import_sequences_cats("seqdata/mmc1.seq", SEQCLASS_ECM, &conn);
		//import_sequences("seqdata/NEGATIVEVIRON.fasta", SEQCLASS_NON_ECM, &conn);
		//import_sequences("seqdata/POSITIVEVIRON.fasta", SEQCLASS_NON_ECM, &conn);
		//return 0;
		//AssignGroup();
		//libdwtTerminate();
		//mclTerminateApplication();
		return 2;
	}
	if (argc > 1 && 0 != strcmp("JOBID", argv[1])) 
	{
		int start = atoi(argv[1]);
		int end = atoi(argv[2]);
		CoreSequencesIterate(start, end, "WEB_SEQS");
	}	
	
    return 0;
}

void AssignGroup()
{
	ADOConn conn;
	stringstream sql;

	// 1. õSEQCLASS=1SEQCLASS=0ĸ
	int count_class0 = conn.GetCount("CORE_SEQS", "STATUS=1 AND SEQCLASS=0 AND ID<=4931");
	int count_class1 = conn.GetCount("CORE_SEQS", "STATUS=1 AND SEQCLASS=1 AND ID<=4931");
	cout << count_class0 << " " << count_class1 << endl;
	// 2. ĴС
	int group_size_class0 = count_class0 / 10;
	int group_size_class1 = count_class1 / 11;
	cout << group_size_class0 << " " << group_size_class1 << endl;
	// 3. ȫΪNULL
	sql << " UPDATE CORE_SEQS SET GROUP_NO=NULL;";
	// 4. ѡз䵽
	for (int i = 1; i <=10; i++)
	{
		//sql << " UPDATE CORE_SEQS SET GROUP_NO=" << i;
		//sql << " WHERE ID IN ";
		//sql << " (SELECT TOP " << group_size_class0 << " ID FROM CORE_SEQS ";
		//sql << " WHERE SEQCLASS=0 AND STATUS=1 AND GROUP_NO IS NULL ORDER BY NEWID() );";

		sql << " UPDATE CORE_SEQS SET GROUP_NO=" << i;
		sql << " WHERE ID IN ";
		sql << " (SELECT TOP " << group_size_class1 << " ID FROM CORE_SEQS ";
		sql << " WHERE  ID<=4931 AND SEQCLASS=1 AND STATUS=1 AND GROUP_NO IS NULL ORDER BY NEWID() );";
	}
	sql << " UPDATE CORE_SEQS SET GROUP_NO=11 ";
	sql << " WHERE  ID<=4931 AND SEQCLASS=1 AND STATUS=1 AND GROUP_NO IS NULL;";
	conn.ExecuteSQL(sql.str().c_str());
	cout << sql.str() << endl;
	cout << "ɷ" << endl;
}

void PrtcSequencesIterate(int start, int end, const char* tableName)
{
	ADOConn conn;
	stringstream sql;
	sql << "SELECT * FROM " << tableName << " WHERE STATUS=1 AND ID BETWEEN " << start << " AND " << end;
	_RecordsetPtr rs = conn.GetRecordSet(sql.str().c_str());
	rs->MoveFirst();
	while(!rs->adoEOF)
	{
		 //DBUpdate_PRTC(FG10_SEG1, rs, &conn);
		 //DBUpdate_PRTC(PP24_SEG1, rs, &conn);
		 //DBUpdate_PRTC(FG10_SEG2, rs, &conn);
		 //DBUpdate_PRTC(PP24_SEG2, rs, &conn);
		 //TranformData("PRTC_SEQS", rs, &conn);

		//DBUpdate_PRTC1(ECM_DOMAIN_SCORE, rs, &conn);			// ͬʱ ECM_DOMAIN_SCORE  REPEATED_DOMAINS
		//DBUpdate_PRTC1(REPETITIVE_RESIDUE, rs, &conn);			//  REPETITIVE_RESIDUE
		//DBUpdate_PRTC1(GXY_REPEATS, rs, &conn);					//  GXY_REPEATS
		//DBUpdate_PRTC1(LCGA_EVOL, rs, &conn);					//  L_EVOL, C_EVOL, G_EVOL, A_EVOL
		//DBUpdate_PRTC1(MOLECULAR_WEIGHT, rs, &conn);			//  MOLECULAR_WEIGHT
		//DBUpdate_PRTC1(ALIPHATIC_RESIDUE, rs, &conn);			//  ALIPHATIC_RESIDUE
		//DBUpdate_PRTC1(TYR_CYS_COMPOSITION, rs, &conn);			//  TYR_COMPOSITION, CYS_COMPOSITION

		rs->MoveNext();
	}
}

double *PhysicalProperty24(char* sequence)
{
	int property_count = 24;
	int seqLen = strlen(sequence);

	double *result = (double*)malloc(property_count * sizeof(double));
	std::memset(result, 0, property_count * sizeof(double));

	for (int i = 0; i < property_count; i ++)
		for (int j = 0; j < seqLen; j ++)
			result[i] += PSEAAC_PROP[i][GetIndexInAMINOACIDS(sequence[j])];

	for (int i = 0; i < property_count; i ++)
		result[i] =  result[i] / seqLen;
	return result;
}


void DBUpdate_PRTC1(int type, _RecordsetPtr rs, ADOConn* conn)
{
	_bstr_t id = GetCollect(rs, "ID");
	_bstr_t acc_id = GetCollect(rs, "ACC_ID");
	_bstr_t seq = GetCollect(rs, "SEQUENCE");
	char* sequence = seq;
	stringstream sql;
	sql << "UPDATE PRTC1_SEQS SET ";
	if (ECM_DOMAIN_SCORE == type) 
	{
		_RecordsetPtr qrs = conn->GetRecordSet(" SELECT * FROM PFAM ");
		list<string> ids;
		try
		{
			qrs->MoveFirst();
			while(!qrs->adoEOF)
			{
				_bstr_t id = GetCollect(qrs, "PFAM_ACC_S");
				ids.push_back((string)id);
				qrs->MoveNext();
			}
		}
		catch(_com_error &e)
		{
			/*AfxMessageBox(e.Description());*/
		}

		char *tempPtr = curl_request("http://www.uniprot.org/uniprot/"+acc_id+".txt", "", REQUEST_METHOD_GET, true);
		string str = tempPtr;
		delete tempPtr;
		regex pattern("Pfam; (PF\\d+); \\w+; (\\d+)."); 
		string::const_iterator start = str.begin();
		string::const_iterator end = str.end();
		smatch mat;
		int score = 0;
		int repeated = 0;
		stringstream hits;

		while(regex_search(start, end, mat, pattern))
		{  
			string acc_s(mat[1].first, mat[1].second);
			string acc_hits(mat[2].first, mat[2].second);

			// 1. Get PFAM_HITS
			start = mat[0].second;
			hits << acc_s << ":" << acc_hits << ",";

			// 2. Get ECM_DOMAIN_SCORE
			if ( find(ids.begin(), ids.end(), acc_s) != ids.end() )	// PFAM
			{
				score = 1;
				repeated += ( atoi(acc_hits.c_str()) > 1 ? atoi(acc_hits.c_str()) : 0 );
			}
		}

		sql << "ECM_DOMAIN_SCORE=" << score << ",";
		sql << "REPEATED_DOMAINS=" << repeated << ",";
		sql << "PFAM_HITS='" << hits.str() << "'";

		
	}
	else if (REPETITIVE_RESIDUE == type)
	{
		sql << "REPETITIVE_RESIDUE='";
		sql << featureConstruction_RepetitiveResidue(sequence);
		sql << "'";
	}
	else if (GXY_REPEATS == type)
	{
		sql << "GXY_REPEATS='";
		sql << featureConstruction_GXY_Repeats(sequence);
		sql << "'";
	}
	else if (LCGA_EVOL == type)
	{
		_bstr_t blast_3_jobid = GetCollect(rs, "BLAST_3_JOBID");
		stringstream url;
		url << URL_PSIBLAST_RESULT << (char*)blast_3_jobid << "/pssm";
		char * tempPtr = curl_request(url.str().c_str(), "", REQUEST_METHOD_GET, true);
		string str = tempPtr;
		delete tempPtr;
		double *result = BlastResultToPSSM(str, sequence, true);
		double l_evol = result[0];
		double c_evol = result[1];
		double g_evol = result[2];
		double a_evol = result[3];
		delete result;
		
		sql << "L_EVOL='" << l_evol << "',";
		sql << "C_EVOL='" << c_evol << "',";
		sql << "G_EVOL='" << g_evol << "',";
		sql << "A_EVOL='" << a_evol << "'";
	}
	else if (MOLECULAR_WEIGHT == type)
	{
		sql << "MOLECULAR_WEIGHT='";
		sql << featureConstruction_Molecular_Weight(sequence);
		sql << "'";
	}
	else if (ALIPHATIC_RESIDUE == type)
	{
		sql << "ALIPHATIC_RESIDUE='";
		sql << featureConstruction_Aliphatic_Residue(sequence, "AGILVP");
		sql << "'";
	}
	else if (TYR_CYS_COMPOSITION == type)
	{
		
		double *result =  featureConstruction_Composition(sequence, "CT");

		sql << "CYS_COMPOSITION='";
		sql << result[0];
		sql << "',";
		sql << "TYR_COMPOSITION='";
		sql << result[1];
		sql << "'";

		delete result;
	}

	

	sql << " WHERE ID=" << (char*)id;
	conn->ExecuteSQL(sql.str().c_str());
	using namespace std;
	cout << sql.str() << endl;
}

void DBUpdate_PRTC(int type, _RecordsetPtr rs, ADOConn* conn)
{
	_bstr_t id = GetCollect(rs, "ID");
	_bstr_t seq = GetCollect(rs, "SEQUENCE");
	char* sequence = seq;
	stringstream sql;
	sql << "UPDATE PRTC_SEQS SET ";
	if (FG10_SEG1 == type) 
	{
		sequence[30] = '\0';
		int *result = featureConstruction_group_transform(sequence, COMMON_GROUP, COMMON_GROUP_LEADER);
		sql << "FG10_SEG1='";
		for(int k=0;k<10;k++)
			sql << (double)result[k]/strlen(sequence) << '|';
		sql << "'";
	}
	else if (PP24_SEG1 == type) 
	{
		sequence[30] = '\0';
		double *result = PhysicalProperty24(sequence);
		sql << "PP24_SEG1='";
		for(int k=0;k<24;k++)
			sql << (double)result[k] << '|';
		sql << "'";
	}
	else if (FG10_SEG2 == type) 
	{
		int *result = featureConstruction_group_transform(sequence+30, COMMON_GROUP, COMMON_GROUP_LEADER);
		sql << "FG10_SEG2='";
		for(int k=0;k<10;k++)
			sql << (double)result[k]/strlen(sequence) << '|';
		sql << "'";
	}
	else if (PP24_SEG2 == type) 
	{
		double *result =  PhysicalProperty24(sequence+30);
		sql << "PP24_SEG2='";
		for(int k=0;k<24;k++)
			sql << (double)result[k] << '|';
		sql << "'";
	}

	sql << " WHERE ID=" << (char*)id;
	conn->ExecuteSQL(sql.str().c_str());
	using namespace std;
	//cout << sql.str() << endl;
}

void SequencesIterate(const char* whereStr, const char* dbTableName)
{
	ADOConn conn;
	//char sql[MAX_PATH],type[MAX_PATH];
	//GetPrivateProfileString("DBUpdate","SQLQuery","SELECT * FROM CORE_SEQS WHERE STATUS=1 AND ID BETWEEN ",	// Ĭֵ
	//							sql, MAX_PATH, "./config.ini");
	stringstream sql;
	sql << " SELECT * FROM " << dbTableName << " " << whereStr;
	_RecordsetPtr rs = conn.GetRecordSet(sql.str().c_str());
	rs->MoveFirst();
	while(!rs->adoEOF)
	{
		//DBUpdate(FREQUENCY_FUNCTIONAL_GROUPS, rs, &conn, dbTableName);	// -Ƶ
		//DBUpdate(DISORDER_SCORES, rs, &conn, dbTableName);				// -DISORDER
		//DBUpdate(AB_TRANSITIONS, rs, &conn, dbTableName);				// -AB_TRANSITIONS
		//DBUpdate(DISTRIBUTION, rs, &conn, dbTableName);					// -DISTRIBUTION
		//DBUpdate(INFO_ENTROPY, rs, &conn, dbTableName);					// -INFO_ENTROPY
		//DBUpdate(DWT_HYDROPHOBIC, rs, &conn, dbTableName);				// -SPECTRAL_CHARACTERISTICS_DWT_HYDROPHOBIC
		//DBUpdate(DWT_ACCESSIBLE, rs, &conn, dbTableName);				// -SPECTRAL_CHARACTERISTICS_DWT_ACCESSIBLE
		//DBUpdate(DWT_FLEXIBILITY, rs, &conn, dbTableName);				// -SPECTRAL_CHARACTERISTICS_DWT_FLEXIBILITY
		//DBUpdate(PSEAAC, rs, &conn, dbTableName);						// -PSEAAC
		//DBUpdate(FUNCTIONAL_DOMAINS_INFO, rs, &conn, dbTableName);		// -FUNCTIONAL_DOMAINS_INFO
		//DBUpdate(BLAST_1_JOBID, rs, &conn, dbTableName);				// -BLAST_1_JOBID
		//DBUpdate(PSIPRED_SUBMIT, rs, &conn, dbTableName);				// -ṹ-ύ


		//DBUpdate(BLAST_2_JOBID, rs, &conn, dbTableName);				// -BLAST_2_JOBID
		//DBUpdate(BLAST_3_JOBID, rs, &conn, dbTableName);				// -BLAST_3_JOBID		
		


		DBUpdate(BLAST_3_RESULT, rs, &conn, dbTableName);				// -BLAST_3_RESULTʵʸPSEUDO_PSSM
		//DBUpdate(PSIPRED_RESULT, rs, &conn, dbTableName);				// -ṹ-ѯ	
		//TranformData(dbTableName, rs, &conn);


		//DBUpdate(TEMP_TEST_DATA, rs, &conn, dbTableName);				// -ʱṹPSEUDO_PSSMڲ
		//DBUpdate(BLAST_1_STATUS, rs, &conn, dbTableName);				// -BLAST_1_STATUS
		//DBUpdate(BLAST_2_STATUS, rs, &conn, dbTableName);				// -BLAST_2_STATUS
		//DBUpdate(BLAST_3_STATUS, rs, &conn, dbTableName);				// -BLAST_3_STATUS

		//AddInterPro(rs, &conn);


		rs->MoveNext();
	}

	// close libray and application
	libdwtTerminate();
	mclTerminateApplication();
}

void WebSequencesIterate(char* jobid, const char* dbTableName)
{
	char whereStr[100];
	sprintf_s(whereStr, "WHERE STATUS=1 AND JOBID='%s'", jobid);
	SequencesIterate(whereStr, dbTableName);
}

void CoreSequencesIterate(int start, int end, const char* dbTableName)
{
	char whereStr[100];
	sprintf_s(whereStr, "WHERE STATUS=1 AND ID BETWEEN %d AND %d", start, end);
	SequencesIterate(whereStr, dbTableName);
}



void split(char *src, const char *separator, char **dest, int *num)
{
	char *pNext;
	int count = 0;

	if (src == NULL || strlen(src) == 0) return;
	if (separator == NULL || strlen(separator) == 0) return; 

	pNext = strtok(src,separator);

	while(pNext != NULL)
	{
		*dest++ = pNext;
		++count;
		pNext = strtok(NULL,separator);
	}

	*num = count;
}

void TranformDataSingle(const char* srcColumnName, const char* dstColumnsPre, const int dstColumnsNum, 
		const char* delimeter, _RecordsetPtr rs, stringstream *sql)
{
	_bstr_t temp = GetCollect(rs, srcColumnName);
	if (temp.length() == 0) return;
	char **data = new char*[dstColumnsNum];
	int num = 0;
	split(temp, delimeter, data, &num);
	for (int i = 1; i <= dstColumnsNum; i++) 
	{
		*sql << dstColumnsPre << i << "='" << data[i-1] << "',";
	}
	delete data;
}

void TranformData(const char* tableName, _RecordsetPtr rs, ADOConn* conn)
{
	_bstr_t id = GetCollect(rs, "ID");
	stringstream sql;
	sql << "UPDATE " << tableName << " SET ";
	if (tableName == "CORE_SEQS" || tableName == "WEB_SEQS")
	{
		TranformDataSingle("DISTRIBUTION", "DISTRIBUTION_", 20, "|", rs, &sql);
		TranformDataSingle("FREQUENCY_FUNCTIONAL_GROUPS", "FREQUENCY_FUNCTIONAL_GROUPS_", 10, "|", rs, &sql);
		TranformDataSingle("INFO_ENTROPY", "INFO_ENTROPY_", 2, "|", rs, &sql);		
		TranformDataSingle("DWT_HYDROPHOBIC", "DWT_HYDROPHOBIC_", DWT_PROP_NUM, "|", rs, &sql);
		TranformDataSingle("DWT_ACCESSIBLE", "DWT_ACCESSIBLE_", DWT_PROP_NUM, "|", rs, &sql);
		TranformDataSingle("DWT_FLEXIBILITY", "DWT_FLEXIBILITY_", DWT_PROP_NUM, "|", rs, &sql);
		TranformDataSingle("PSEUDO_PSSM", "PSSM_", 80, "|", rs, &sql);
		TranformDataSingle("DISORDER_SCORES", "DISORDER_SCORES_", 8, "|", rs, &sql);
		TranformDataSingle("SECONDARY_STRUCTRAL_INFO", "SECONDARY_STRUCTRAL_INFO_", 51, "|", rs, &sql);
		TranformDataSingle("AB_TRANSITIONS", "AB_TRANSITIONS_", 45, "|", rs, &sql);
		TranformDataSingle("PSEAAC", "PSEAAC_", 40, "|", rs, &sql);
	}
	else if (tableName == "PRTC_SEQS")
	{
		TranformDataSingle("FG10_SEG1", "FG10_SEG1_", 10, "|", rs, &sql);
		TranformDataSingle("PP24_SEG1", "PP24_SEG1_", 24, "|", rs, &sql);
		TranformDataSingle("FG10_SEG2", "FG10_SEG2_", 10, "|", rs, &sql);
		TranformDataSingle("PP24_SEG2", "PP24_SEG2_", 24, "|", rs, &sql);
	}
	
	sql.seekp( (int)sql.tellp()-1 ); // remove the last character
	sql << " WHERE ID=" << (char*)id;
	conn->ExecuteSQL(sql.str().c_str());
	cout << sql.str() << endl;
}

void AddInterPro(_RecordsetPtr rs, ADOConn* conn)
{
	_bstr_t id = GetCollect(rs, "ID");
	_bstr_t acc_id = GetCollect(rs, "ACC_ID");

	char *tempPtr = curl_request("http://www.uniprot.org/uniprot/"+acc_id+".txt", "", REQUEST_METHOD_GET, true);
	string str = tempPtr;
	delete tempPtr;
	//cout << str << endl;
	regex pattern("InterPro; (IPR\\d+);"); 
	string::const_iterator start = str.begin();
	string::const_iterator end = str.end();
	smatch mat;
	stringstream sql;
			
	while(regex_search(start, end, mat, pattern))
	{  
		string temp(mat[1].first, mat[1].second);
		start = mat[0].second;
		sql << "INSERT INTO InterPro(ACC_ID,INTERPRO_ID) VALUES('";
		sql << acc_id << "','" << temp << "');";
	}
	if (sql.str().empty()) {
		sql << "INSERT INTO InterPro(ACC_ID,INTERPRO_ID) VALUES('";
		sql << acc_id << "','');";
	}
	conn->ExecuteSQL(sql.str().c_str());
	cout << sql.str() << endl;
}



void DBUpdate(int type, _RecordsetPtr rs, ADOConn* conn, const char* dbTableName)
{
	_bstr_t id = GetCollect(rs, "ID");
	_bstr_t acc_id = GetCollect(rs, "ACC_ID");
	_bstr_t seq = GetCollect(rs, "SEQUENCE");
	_bstr_t psipred_jobid = GetCollect(rs, "PSIPRED_JOBID");
	_bstr_t blast_1_jobid = GetCollect(rs, "BLAST_1_JOBID");
	_bstr_t blast_2_jobid = GetCollect(rs, "BLAST_2_JOBID");
	_bstr_t blast_3_jobid = GetCollect(rs, "BLAST_3_JOBID");
	char* sequence = seq;
	stringstream sql;
	sql << "UPDATE "<<dbTableName<<" SET ";

	if (TEMP_TEST_DATA == type)
	{
		sql << "PSEUDO_PSSM=(SELECT PSEUDO_PSSM FROM WEB_SEQS WHERE ID=1),";
		sql << "SECONDARY_STRUCTRAL_INFO=(SELECT SECONDARY_STRUCTRAL_INFO FROM WEB_SEQS WHERE ID=1)";
	}
	if (FREQUENCY_FUNCTIONAL_GROUPS == type) 
	{
		int *result = featureConstruction_group_transform(sequence, COMMON_GROUP, COMMON_GROUP_LEADER);
		sql << "FREQUENCY_FUNCTIONAL_GROUPS='";
		for(int k=0;k<10;k++)
			sql << (double)result[k]/strlen(sequence) << '|';
		sql << "'";
	}
	else if (AB_TRANSITIONS == type)
	{
		double *result = SC_ABTransitions(sequence, COMMON_GROUP, COMMON_GROUP_LEADER);
		sql << "AB_TRANSITIONS='";
		for(int k=0;k<45;k++)
			sql << result[k] << '|';
		sql << "'";
	}
	else if (DISTRIBUTION == type)
	{
		double *result = SC_distributionOfAminoAcid(sequence);
		sql << "DISTRIBUTION='";
		for(int k=0;k<20;k++)
			sql << result[k] << '|';
		sql << "'";
	}
	else if (INFO_ENTROPY == type)
	{
		double *result = SC_entropyOfComposition(sequence);
		sql << "INFO_ENTROPY='";
		for(int k=0;k<2;k++)
			sql << result[k] << '|';
		sql << "'";
	}
	else if (DWT_HYDROPHOBIC == type)
	{
		double *result = featureConstruction_DWT(sequence, 0);
		sql << "DWT_HYDROPHOBIC='";
		for(int k=0;k<DWT_PROP_NUM;k++)
			sql << result[k] << '|';
		sql << "'";
	}
	else if (DWT_ACCESSIBLE == type)
	{
		double *result = featureConstruction_DWT(sequence, 1);
		sql << "DWT_ACCESSIBLE='";
		for(int k=0;k<DWT_PROP_NUM;k++)
			sql << result[k] << '|';
		sql << "'";
	}
	else if (DWT_FLEXIBILITY == type)
	{
		double *result = featureConstruction_DWT(sequence, 2);
		sql << "DWT_FLEXIBILITY='";
		for(int k=0;k<DWT_PROP_NUM;k++)
			sql << result[k] << '|';
		sql << "'";
	}
	else if (PSEAAC == type)
	{
		double *result = featureConstruction_PSEAAC(sequence);
		sql << "PSEAAC='";
		for(int k=0;k<PSEAAC_ETA_MAX+AMINOACIDS_NUM;k++)
			sql << result[k] << '|';
		sql << "'";
	}
	else if (BLAST_1_JOBID == type)
	{		
		if (blast_1_jobid.length() > 0) return;
		stringstream params;
		params << COMMON_PARAM_PSIBLAST << "&sequence=" << sequence;
		char *tempPtr = curl_request(URL_PSIBLAST_RUN, params.str().c_str(), REQUEST_METHOD_POST);
		string str = tempPtr;
		delete tempPtr;
		while (string::npos != str.find("<error>"))
		{
			tempPtr = curl_request(URL_PSIBLAST_RUN, params.str().c_str(), REQUEST_METHOD_POST);
			str = tempPtr;
			delete tempPtr;
		}
		if (string::npos != str.find("psiblast-"))
			sql << "BLAST_1_JOBID='" << str << "'";
		else return;	// δɹ򲻼ִ
	}
	else if (BLAST_1_STATUS == type)
	{
		stringstream url;
		url << URL_PSIBLAST_STATUS << (char*)blast_1_jobid;
		char *tempPtr = curl_request(url.str().c_str(), "", REQUEST_METHOD_GET);
		string str = tempPtr;
		delete tempPtr;
		sql << "BLAST_1_STATUS='" << str << "'";
	}
	else if (BLAST_2_JOBID == type)
	{	
		if (blast_2_jobid.length() > 0) return;

		if (blast_1_jobid.length() == 0) {
			stringstream qSql;
			qSql << " SELECT BLAST_1_JOBID FROM " << dbTableName;
			qSql << " WHERE ID=" << id;
			_RecordsetPtr qrs = conn->GetRecordSet(qSql.str().c_str());
			try
			{
				qrs->MoveFirst();
				if (!qrs->adoEOF)
					blast_1_jobid = GetCollect(qrs, "BLAST_1_JOBID");
			}
			catch(_com_error &e)
			{
				//
			}
		}
		if (blast_1_jobid.length() == 0) return;

		stringstream params;
		params << COMMON_PARAM_PSIBLAST <<"&previousjobid=" << (char*)blast_1_jobid;
		char *tempPtr = curl_request(URL_PSIBLAST_RUN, params.str().c_str(), REQUEST_METHOD_POST);
		string str = tempPtr;
		delete tempPtr;
		cout << str << endl;
		while (string::npos != str.find("<error>"))
		{
			tempPtr = curl_request(URL_PSIBLAST_RUN, params.str().c_str(), REQUEST_METHOD_POST);
			str = tempPtr;
			delete tempPtr;
			cout << str << endl;
		}
		if (string::npos != str.find("psiblast-"))
			sql << "BLAST_2_JOBID='" << str << "'";
		else return;	// δɹ򲻼ִ
	}
	else if (BLAST_2_STATUS == type)
	{		
		stringstream url;
		url << URL_PSIBLAST_STATUS << (char*)blast_2_jobid;
		char *tempPtr = curl_request(url.str().c_str(), "", REQUEST_METHOD_GET);
		string str = tempPtr;
		delete tempPtr;
		sql << "BLAST_2_STATUS='" << str << "'";
	}
	else if (BLAST_3_JOBID == type)
	{
		if (blast_3_jobid.length() > 0) return;

		if (blast_2_jobid.length() == 0) {
			stringstream qSql;
			qSql << " SELECT BLAST_2_JOBID FROM " << dbTableName;
			qSql << " WHERE ID=" << id;
			_RecordsetPtr qrs = conn->GetRecordSet(qSql.str().c_str());
			try
			{
				qrs->MoveFirst();
				if (!qrs->adoEOF)
					blast_2_jobid = GetCollect(qrs, "BLAST_2_JOBID");
			}
			catch(_com_error &e)
			{
				//
			}
		}
		if (blast_2_jobid.length() == 0) return;

		stringstream params;
		params << COMMON_PARAM_PSIBLAST << "&previousjobid=" << (char*)blast_2_jobid;
		char *tempPtr = curl_request(URL_PSIBLAST_RUN, params.str().c_str(), REQUEST_METHOD_POST);
		string str = tempPtr;
		delete tempPtr;
		while (string::npos != str.find("<error>"))
		{
			tempPtr = curl_request(URL_PSIBLAST_RUN, params.str().c_str(), REQUEST_METHOD_POST);
			str = tempPtr;
			delete tempPtr;
		}
		if (string::npos != str.find("psiblast-"))
			sql << "BLAST_3_JOBID='" << str << "'";
		else return;	// δɹ򲻼ִ
	}
	else if (BLAST_3_STATUS == type)
	{		
		stringstream url;
		url << URL_PSIBLAST_STATUS << (char*)blast_3_jobid;
		char *tempPtr = curl_request(url.str().c_str(), "", REQUEST_METHOD_GET);
		string str = tempPtr;
		delete tempPtr;
		sql << "BLAST_3_STATUS='" << str << "'";
	}
	else if (BLAST_3_RESULT == type)
	{		
		_bstr_t pseudo_pssm = GetCollect(rs, "PSEUDO_PSSM");
		if (pseudo_pssm.length() > 0) return;

		if (blast_3_jobid.length() == 0) {
			stringstream qSql;
			qSql << " SELECT BLAST_3_JOBID FROM " << dbTableName;
			qSql << " WHERE ID=" << id;
			_RecordsetPtr qrs = conn->GetRecordSet(qSql.str().c_str());
			try
			{
				qrs->MoveFirst();
				if (!qrs->adoEOF)
					blast_3_jobid = GetCollect(qrs, "BLAST_3_JOBID");
			}
			catch(_com_error &e)
			{
				//
			}
		}
		if (blast_3_jobid.length() == 0) return;

		stringstream url;
		url << URL_PSIBLAST_RESULT << (char*)blast_3_jobid << "/pssm";
		char *tempPtr = curl_request(url.str().c_str(), "", REQUEST_METHOD_GET, true);
		string str = tempPtr;
		delete tempPtr;
		while (str.length() == 0)
		{
			tempPtr = curl_request(url.str().c_str(), "", REQUEST_METHOD_GET, true);
			str = tempPtr;
			delete tempPtr;
		}
		double *result = BlastResultToPSSM(str, sequence);
		sql << "PSEUDO_PSSM='";
		for(int k=0;k<80;k++)
			sql << result[k] << '|';
		sql << "'";
		delete result;
	}
	else if (PSIPRED_SUBMIT == type)
	{		
		if (GetCollect(rs, "PSIPRED_JOBID").length() > 0) return;	// Ѵڽ
		int seqLen = strlen(sequence);
		if (seqLen < 1500) 
		{
			PsipredSubmitRequest request;
			PsipredSubmitResponse response;
			request.sequence = sequence;
			request.email = "";
			request.name = acc_id;
			request.complex = "true";
			request.membrane = "false";
			request.coil = "false";
			request.msa_control = "all";
			response.state = "0";
			while ("0" == response.state) {				
				if (-1 == SoapClient_Psipred("PsipredSubmit", &request, &response)) break;
				cout << "Waiting..." << endl;
				Sleep(1000);
			}
			sql << "PSIPRED_JOBID='" << response.job_id << "', PSIPRED_STATE='" << response.state << "'";
		}
		else
		{
			DompredSubmitRequest request;
			DompredSubmitResponse response;
			request.sequence = sequence;
			request.email = "";
			request.name = acc_id;
			request.eval = "0.01";
			request.iterations = "5";
			request.secpro = "yes";
			request.pp = "yes";
			response.state = "0";
			while ("0" == response.state) {
				if (-1 == SoapClient_Psipred("DompredSubmit", &request, &response)) break;
				cout << "Waiting..." << endl;
				Sleep(1000);
			}
			sql << "PSIPRED_JOBID='" << response.job_id << "', PSIPRED_STATE='" << response.state << "'";
		}		
	}
	else if (PSIPRED_RESULT == type)
	{
		if (GetCollect(rs, "SECONDARY_STRUCTRAL_INFO").length() > 0) return;	// Ѵڽ
		int ok = 0;
		while (ok < 10)
		{
			int seqLen = strlen(sequence);
			stringstream result;
			if (seqLen < 1500) 
			{
				PsipredResultRequest request;
				PsipredResultResponse response;
				request.job_id = psipred_jobid;
				SoapClient_Psipred("PsipredResult", &request, &response);
				//cout << response.message << endl;
				//cout << response.job_id << endl;
				//cout << response.psipred_postscript << endl;
				//cout << response.psipred_results << endl;
				//cout << response.state << endl;
				char *tempPtr = curl_request(response.psipred_results.c_str(), "", REQUEST_METHOD_GET, true);
				string str = tempPtr;
				delete tempPtr;
				//cout << str << endl;
				regex pattern("Pred:\\s+([A-Z]+)"); 
				string::const_iterator start = str.begin();
				string::const_iterator end = str.end();
				smatch mat;

				while(regex_search(start, end, mat, pattern))
				{  
					string temp(mat[1].first, mat[1].second);
					start = mat[0].second;
					result << temp;
				}
			}
			else
			{
				string resultsPageUrl = "http://bioinf.cs.ucl.ac.uk/psipred/result/" + psipred_jobid;
				char *tempPtr = curl_request(resultsPageUrl.c_str(), "", REQUEST_METHOD_GET, true);
				string pageContent = tempPtr;
				delete tempPtr;
				//cout << pageContent << endl;
				regex pattern("<a href=\"\/bio_serf\/getresultattached\/(\\d+)\">PSIPRED results in plain text format<\/a>"); 
				string::const_iterator start = pageContent.begin();
				string::const_iterator end = pageContent.end();
				smatch mat;
				stringstream psiblastOutputUrl;
				psiblastOutputUrl << "http://bioinf.cs.ucl.ac.uk/bio_serf/getresultattached/";
				if(regex_search(start, end, mat, pattern))
				{  
					string temp(mat[1].first, mat[1].second);
					start = mat[0].second;
					psiblastOutputUrl << temp;
				}
				//cout << psiblastOutputUrl.str() << endl;
				tempPtr = curl_request(psiblastOutputUrl.str().c_str(), "", REQUEST_METHOD_GET, true);
				string str = tempPtr;
				delete tempPtr;

				//cout << str << endl;
				regex pattern1("Pred:\\s+([A-Z]+)");
				string::const_iterator start1 = str.begin();
				string::const_iterator end1 = str.end();
				smatch mat1;
				while(regex_search(start1, end1, mat1, pattern1))
				{  
					string temp(mat1[1].first, mat1[1].second);
					start1 = mat1[0].second;
					result << temp;
				}
			}
			cout << result.str() << endl;
			SecondStructureStatistic statistics[3] = {0};
			calcSegmentStatistics((char *)(result.str().c_str()), "CHE", statistics);
			double *temp = groupInCHE(sequence, (char *)result.str().c_str(), COMMON_GROUP, COMMON_GROUP_LEADER, "CHE");

			sql << "SECONDARY_STRUCTRAL_INFO='";
			for (int i = 0; i< 3; i++) {
				SecondStructureStatistic s = statistics[i];
				sql << s.ElementFreq << '|';
				sql << s.SegmentsFreq << '|';
				sql << s.SegemntLengthMax << '|';
				sql << s.SegemntLengthMin << '|';
				sql << s.SegemntLengthAvg << '|';
				sql << s.SegemntLengthSigma << '|';
				sql << s.Distribution << '|';
			}
			for (int i = 0; i<30; i++) {
				sql << temp[i] << '|';
			}
			sql << "'";
			if ( string::npos == sql.str().find("IND") ) 
				ok = 10;
			else
			{
				ok ++;
				if (ok == 9) return;
			}
		}
			
	}
	else if (DISORDER_SCORES == type)
	{
		DisorderStatistic statistics;
		featureConstruction_Disorder(sequence, &statistics);
		sql << "DISORDER_SCORES='";
		sql << statistics.average << '|';
		sql << statistics.sigma << '|';
		sql << statistics.DisorderedSegmentLengthMax << '|';
		sql << statistics.DisorderedSegmentLengthMin << '|';
		sql << statistics.DisorderedSegmentsNum << '|';
		sql << statistics.OrderedSegmentLengthMax << '|';
		sql << statistics.OrderedSegmentLengthMin << '|';
		sql << statistics.OrderedSegmentsNum << '|';
		sql << "'";
	}
	else if (FUNCTIONAL_DOMAINS_INFO == type)
	{
		stringstream qSql;
		qSql << " SELECT S.ID FROM ViewInterproSelected AS S ";
		qSql << " LEFT JOIN Interpro AS I ";
		qSql << " ON I.INTERPRO_ID=S.INTERPRO_ID ";
		qSql <<" WHERE I.ACC_ID='" << acc_id << "'";
		_RecordsetPtr qrs = conn->GetRecordSet(qSql.str().c_str());
		cout << qSql.str() << endl;
		list<int> ids;
		try
		{
			qrs->MoveFirst();
			while(!qrs->adoEOF)
			{
				_bstr_t id = GetCollect(qrs, "ID");
				ids.push_back(atoi(id));
				qrs->MoveNext();
			}
		}
		catch(_com_error &e)
		{
			/*AfxMessageBox(e.Description());*/
		}
		for (int i = 1; i <= FUNCTIONAL_DOMAINS_PROPNUM; i ++)
		{
			sql << "FUNCTIONAL_DOMAINS_INFO_" << i << "='";
			sql << ( find(ids.begin(), ids.end(), i) == ids.end() ? 0 : 1);
			sql << "',";
		}
		sql.seekp( (int)sql.tellp()-1 ); // ȥһַ
	}
		
	sql << " WHERE ID=" << (char*)id;
	conn->ExecuteSQL(sql.str().c_str());
	using namespace std;
	cout << sql.str() << endl;
}

double *groupInCHE(char* sequence, char* seqSecondStructure, char **group, char* representation, char* collection)
{
	int groupCount = strlen(representation);
	int collectionLen = strlen(collection);
	
	double *result = (double*)malloc( groupCount * collectionLen * sizeof(double));
	std::memset(result, 0, groupCount * collectionLen * sizeof(double));

	int *groupTotal = (int*)malloc( groupCount * sizeof(int));
	std::memset(groupTotal, 0, groupCount * sizeof(int));
	
	for (int i = 0; i < strlen(sequence); i++)
	{
		for(int j=0; j < groupCount; j++)
		{
			if (0 != strchr(group[j], sequence[i]))
			{
				for(int k=0; k < collectionLen; k++)
				{				
					if (seqSecondStructure[i] == collection[k])
					{
						result[j*collectionLen+k]++;
						break;
					}
					
				}
				groupTotal[j]++;
				break;
			}
		}
	}
	for(int j=0; j < groupCount; j++)
		for(int k=0; k < collectionLen; k++)
			if (0 != groupTotal[j]) result[j*collectionLen+k] = result[j*collectionLen+k] / groupTotal[j];
	return result;
}

/************************************************************************/
/* 
	BLASTõPSSM

	is_evol  =>  evolutionary
		  
		  evol_amino_acids  =>  
*/
/************************************************************************/
double *BlastResultToPSSM(string str, char*sequence, bool is_evol)
{
	/*
	ofstream file;
	file.open( "a.txt", ios::out );
	if ( file.is_open() )
	{
			file << str << endl;
	}
	file.close();
	*/
	double *result;

	regex pattern("[A-Z]\\s+([-\\d]+\\s+){20}"); 
	string::const_iterator start = str.begin();
	string::const_iterator end = str.end();
	smatch mat;
	int seqLen = strlen(sequence);
	double *data = (double*)malloc(seqLen * AMINOACIDS_NUM * sizeof(double));
	std::memset(data, 0, seqLen * AMINOACIDS_NUM * sizeof(double));
	int i = 0;
	while(regex_search(start, end, mat, pattern))
	{  
		string msg(mat[0].first, mat[0].second);
		start = mat[0].second;
		
		regex pattern1("[-\\d]+");
		string::const_iterator start1 = msg.begin();
		string::const_iterator end1 = msg.end();
		smatch mat1;
		int j = 0;
		while(regex_search(start1, end1, mat1, pattern1))
		{
			string number(mat1[0].first, mat1[0].second);
			start1 = mat1[0].second;
			double temp = -1 * atoi( number.c_str() );
			temp = exp(temp);
			data[i*AMINOACIDS_NUM+j] = 1 / ( 1 + temp );
			j++;
		}
		i++;
	}

	if (is_evol)
	{
		int evol_amino_acids[] = {1,5,8,11};
		int evol_len = sizeof(evol_amino_acids) / sizeof(int);
		result = (double*)malloc(evol_len * sizeof(double));
		std::memset(result, 0, evol_len * sizeof(double));
		for (int k=0; k<evol_len; k++)
		{
			for (i = 0; i < seqLen; i++)
				result[k] += data[i*AMINOACIDS_NUM + evol_amino_acids[k]];
			//int count = 0;
			//for (i = 0; i < seqLen; i++)
			//{
			//	if (sequence[i] == evol_amino_acids[k])
			//	{
			//		for (int j = 0; j < AMINOACIDS_NUM; j++)
			//		{
			//			result[k] += data[i*AMINOACIDS_NUM + j];
			//			count++;
			//		}
			//	}
			//}
			result[k] = result[k] / seqLen;
		}
		
	}
	else
	{
		result = (double*)malloc(80 * sizeof(double));
		std::memset(result, 0, 80 * sizeof(double));
		for (int k=0; k<4; k++)
		{
			for (int j = 0; j < AMINOACIDS_NUM; j++)
			{
				double sum = 0;
				for (i = 0; i < seqLen-k-1; i++)
				{
					//cout << data[j+i*AMINOACIDS_NUM] << "  " << data[j+(i+1+k)*AMINOACIDS_NUM] << endl;
					sum += pow(data[j+i*AMINOACIDS_NUM]-data[j+(i+1+k)*AMINOACIDS_NUM], 2);
				}
				result[k*AMINOACIDS_NUM + j] = sum/(seqLen-k-1);
			}
		}
	}

	delete data;
	return result;
}

char* curl_request(const char* url, const char * fields, int method, bool join)
{
	char *result = (char*)malloc(1024000 * sizeof(char));
	std::memset(result, 0, 1024000 * sizeof(char));
	
	CURL *curl;
	CURLcode res;
	struct curl_slist *http_header = NULL;
	
	curl = curl_easy_init();
	curl_easy_setopt(curl, CURLOPT_URL, url);
	curl_easy_setopt(curl, CURLOPT_POSTFIELDS, fields);
	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, join ? curl_callback_join:curl_callback);
	curl_easy_setopt(curl, CURLOPT_WRITEDATA, result);
	curl_easy_setopt(curl, CURLOPT_POST, method);
	curl_easy_setopt(curl, CURLOPT_VERBOSE, 1);
	curl_easy_setopt(curl, CURLOPT_HEADER, 1);
	curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1);
	res = curl_easy_perform(curl);
	curl_easy_cleanup(curl);

	return result;
}



size_t curl_callback(void *buffer, size_t size, size_t nmemb, void* userp) {
	char *str = (char*)buffer;
	std::memset(userp, 0, 1024000 * sizeof(char));
	int n = strlen(str);
	std::memcpy(userp, buffer, strlen(str) * sizeof(char) );
    return nmemb;
}

size_t curl_callback_join(void *buffer, size_t size, size_t nmemb, void* userp) {
	
	int res_size = size * nmemb;
	char *str = (char*)buffer;
	char *container = (char*)userp;
	int n = strlen(container);
	std::memcpy(container + n*sizeof(char), buffer, res_size * sizeof(char) );
    return res_size;
}

int *featureConstruction_AD(char* sequence)
{
	/*
	 * http://www.genome.jp/dbget-bin/www_bget?aaindex:BULH740101
	*/
	using namespace std;

	// initialization
	map <char, float> AD_TFES;
	map <char, float> AD_TFES_Standardized;
	AD_TFES.insert ( pair <char, float>  ( 'A', -0.20f ) );
	AD_TFES.insert ( pair <char, float>  ( 'L', -2.46f ) );

	AD_TFES.insert ( pair <char, float>  ( 'R', -0.12f ) );
	AD_TFES.insert ( pair <char, float>  ( 'K', -0.35f ) );

	AD_TFES.insert ( pair <char, float>  ( 'N', 0.08f ) );
	AD_TFES.insert ( pair <char, float>  ( 'M', -1.47f  ) );

	AD_TFES.insert ( pair <char, float>  ( 'D', -0.20f ) );
	AD_TFES.insert ( pair <char, float>  ( 'F', -2.33f ) );

	AD_TFES.insert ( pair <char, float>  ( 'C', -0.45f ) );
	AD_TFES.insert ( pair <char, float>  ( 'P', -0.98f ) );

	AD_TFES.insert ( pair <char, float>  ( 'Q', 0.16f ) );
	AD_TFES.insert ( pair <char, float>  ( 'S', -0.39f ) );

	AD_TFES.insert ( pair <char, float>  ( 'E', -0.30f ) );
	AD_TFES.insert ( pair <char, float>  ( 'T', -0.52f ) );

	AD_TFES.insert ( pair <char, float>  ( 'G', 0.00f ) );
	AD_TFES.insert ( pair <char, float>  ( 'W', -2.01f ) );

	AD_TFES.insert ( pair <char, float>  ( 'H', -0.12f ) );
	AD_TFES.insert ( pair <char, float>  ( 'Y', -2.24f ) );

	AD_TFES.insert ( pair <char, float>  ( 'I', -2.26f ) );
	AD_TFES.insert ( pair <char, float>  ( 'V', -1.56f ) );

	// iterate
	map <char, float>::iterator AD_TFES_Iter1;
	// calculate average
	float sum = 0;
	float AD_TFES_Average = 0;
	for ( AD_TFES_Iter1 = AD_TFES.begin( ); AD_TFES_Iter1 != AD_TFES.end( ); AD_TFES_Iter1++ )
	{
		sum += AD_TFES_Iter1->second;
	}
	AD_TFES_Average = sum / AMINOACIDS_NUM;
	
	// calculate std
	float AD_TFES_std = 0;
	for ( AD_TFES_Iter1 = AD_TFES.begin( ); AD_TFES_Iter1 != AD_TFES.end( ); AD_TFES_Iter1++ )
	{
		AD_TFES_std += pow( AD_TFES_Iter1->second - AD_TFES_Average, 2 );
	}
	AD_TFES_std = sqrt( AD_TFES_std / 20 );
	
	// standardize
	float Standardized_Sum = 0;
	float AD_TFES_Standardized_Average = 0;
	for ( AD_TFES_Iter1 = AD_TFES.begin( ); AD_TFES_Iter1 != AD_TFES.end( ); AD_TFES_Iter1++ )
	{
		float temp = (AD_TFES_Iter1->second -  AD_TFES_Average) / AD_TFES_std;
		AD_TFES_Standardized.insert ( pair <char, float>  ( AD_TFES_Iter1->first, temp ) );
		Standardized_Sum += temp;
	}
	AD_TFES_Standardized_Average = Standardized_Sum / AMINOACIDS_NUM;
	
	// AC(d)
	const int MAX_D = 30;
	float Result_AC[MAX_D] = {0};
	float Result_I[MAX_D] = {0};
	float Result_C[MAX_D] = {0};
	int N = strlen(sequence);
	for (int d = 1; d <= MAX_D; d ++)
	{
		float num_1 = 0;
		float num_2 = 0;
		for (int i = 1; i <= N-d; i++)
		{	
			float temp_a = AD_TFES_Standardized.find(sequence[i-1])->second;
			float temp_b = AD_TFES_Standardized.find(sequence[i-1+d])->second;
			Result_AC[d-1] += temp_a * temp_b;
			num_1 += (temp_a - AD_TFES_Standardized_Average) * (temp_b - AD_TFES_Standardized_Average);
			num_2 += pow( temp_a - temp_b, 2);
		}
		num_1 /= (N-d);
		num_2 /= ( 2 * (N-d) );

		float den = 0;
		for (int i = 1; i <= N; i++)
		{
			float temp_a = AD_TFES_Standardized.find(sequence[i-1])->second; 
			den += pow( temp_a - AD_TFES_Standardized_Average, 2);
		}
		float den_1 = den / N;
		float den_2 = den / (N-1);
		Result_I[d-1] = num_1 / den_1;
		Result_C[d-1] = num_2 / den_2;
	}


	return 0;
}

int *featureConstruction_LZC(char* sequence, char **group, char* representation)
{
	int sequenceLen = strlen(sequence);
	featureConstruction_group_transform(sequence, group, representation);
	//char** fragments = (char**)malloc( sequenceLen * sizeof(char));
	//memset(fragments, 0, sequenceLen * sizeof(char));
	char fragments[200][100];

	sprintf_s(fragments[0], "%c", sequence[0]);

	// second fragment
	sprintf_s(fragments[1], "");
	int i = 0;
	for (i = 1; i < sequenceLen; i++)
	{
		sprintf_s(fragments[1], "%s%c", fragments[1], sequence[i]);
		if (sequence[i] != sequence[0]) break;
	}

	// printf("fragments[0]: %s \n", fragments[0]);
	// printf("fragments[1]: %s \n", fragments[1]);

	char *finishedSequence = strcat(fragments[0], fragments[1]);

	int fragmentIndex = 2;
	sprintf_s(fragments[fragmentIndex], "");
	// others
	for (i++;i < sequenceLen; i++) {
		sprintf_s(fragments[fragmentIndex], "%s%c", fragments[fragmentIndex], sequence[i]);
		if ( 0 == strstr(finishedSequence, fragments[fragmentIndex]) )
		{
			//printf("fragments[%d]: %s \n", fragmentIndex, fragments[fragmentIndex]);
			strcat(finishedSequence, fragments[fragmentIndex]);
			fragmentIndex++;
			sprintf_s(fragments[fragmentIndex], "");
		}
		else
		{
			if (i == sequenceLen-1)
			{
				//printf("fragments[%d]: %s \n", fragmentIndex, fragments[fragmentIndex]);
			}
		}
	}

	printf("%d \n", fragmentIndex);




	return 0;
}

int *featureConstruction_GD_transition_distribution(char* sequence, char **group, char* representation)
{
	float position[5] = {0.0, 0.25, 0.5, 0.75, 1.00};
	int positionCount = sizeof(position) / sizeof(int);
	int groupCount = strlen(representation);
	int countTransiton = (groupCount-1) * groupCount / 2;
	
	int *positionContainer = (int*)malloc( countTransiton * positionCount * sizeof(int));
	std::memset(positionContainer, 0, countTransiton * positionCount * sizeof(int));

	int *transitonsNumbering = featureConstruction_GD_transitions(sequence, group, representation);
	for (int i = 0; i < countTransiton; i++)
	{
		for (int j = 0; j < positionCount; j++ ) 
		{
			int temp = (int)( transitonsNumbering[i] * position[j] );
			positionContainer[i*positionCount + j] = temp < 1 ? 1 : temp;

			printf("%dϵ%fΪ%d \n", i+1, position[j], positionContainer[i*positionCount + j]);
		}
	}

	printf("**************************\n\n");

	featureConstruction_GD_numbering(sequence, group, representation);	// תsequence
	
	float *positionPercentContainer = (float*)malloc( countTransiton * positionCount * sizeof(float));
	std::memset(positionPercentContainer, 0, countTransiton * positionCount * sizeof(float));
	int sequenceLen = strlen(sequence);
	for (int k = 0; k < groupCount; k++)
	{
		for(int m = k + 1; m < groupCount; m ++)
		{
			int index = (groupCount * 2 - k - 3) * k / 2 + m - 1;
			int tempCount = 0;
			int tempIndex = 0;
			for (int n = 0; n < strlen(sequence)-1; n++)
			{		
				if ( (sequence[n] == representation[k] && sequence[n+1] == representation[m])
					 || (sequence[n] == representation[m] && sequence[n+1] == representation[k]) )
				{
					tempCount++;
					while (tempCount == positionContainer[index*positionCount + tempIndex])
					{
						positionPercentContainer[index*positionCount + tempIndex] = (float)(n+1)/sequenceLen;
						printf("%dڹؼ%fеλðٷֱΪ%f \n", index+1, position[tempIndex], (float)(n+1)/sequenceLen);
						tempIndex++;
						if (tempIndex > positionCount) break;	
					}
				}
			}
			printf("\n");
		}
	}

	return 0;

}

int *featureConstruction_GD_distribution(char* sequence, char **group, char* representation)
{
	float position[5] = {0.0, 0.25, 0.5, 0.75, 1.00};
	int positionCount = sizeof(position) / sizeof(int);
	int groupCount = strlen(representation);
	
	int *positionContainer = (int*)malloc( groupCount * positionCount * sizeof(int));
	std::memset(positionContainer, 0, groupCount * positionCount * sizeof(int));
	
	int *numbering = featureConstruction_GD_numbering(sequence, group, representation);
	for (int i = 0; i < groupCount; i++)
	{
		for (int j = 0; j < positionCount; j++ ) 
		{
			int temp = (int)( numbering[i] * position[j] );
			positionContainer[i*positionCount + j] = temp < 1 ? 1 : temp;
			
			 
			printf("%c%fΪ%d \n", representation[i], position[j], positionContainer[i*positionCount + j]);
		}
	}

	printf("**************************\n\n");

	featureConstruction_GD_numbering(sequence, group, representation);	// תsequence
	
	float *positionPercentContainer = (float*)malloc( groupCount * positionCount * sizeof(float));
	std::memset(positionPercentContainer, 0, groupCount * positionCount * sizeof(float));
	int sequenceLen = strlen(sequence);
	for (int m = 0; m < groupCount; m++)
	{
		int tempCount = 0;
		int tempIndex = 0;
		for (int k = 0; k < sequenceLen; k++)
		{
			if (representation[m] == sequence[k])
			{
				tempCount ++;
				while (tempCount == positionContainer[m*positionCount + tempIndex])
				{
					positionPercentContainer[m*positionCount + tempIndex] = (float)(k+1)/sequenceLen;
					printf("%cڹؼ%fеλðٷֱΪ%f \n", representation[m], position[tempIndex], (float)(k+1)/sequenceLen);
					tempIndex++;
					if (tempIndex > positionCount) break;	
				}
			}
		}
		printf("\n");
	}
	
	return 0;
}

int *featureConstruction_group_transform(char* sequence, char **group, char* representation)
{
	int groupCount = strlen(representation);
	
	int *result = (int*)malloc( groupCount * sizeof(int));
	std::memset(result, 0, groupCount * sizeof(int));
	
	for (int i = 0; i < strlen(sequence); i++)
	{
		for(int j=0; j < groupCount; j++)
		{
			if (0 == strchr(group[j], sequence[i]))
			{
				continue;
			}
			else
			{
				sequence[i]=representation[j];
				result[j]++;
				break;
			}
		}
	}
	//for(int k=0;k<groupCount;k++)
	//	printf("%sֵƵΪ%f \n", group[k], (float)result[k]/strlen(sequence));

	return result;
}

int *featureConstruction_GD_numbering(char* sequence, char **group, char* representation)
{
	return featureConstruction_group_transform(sequence, group, representation);
}


int *featureConstruction_GD_transitions(char* sequence, char **group, char* representation)
{
	int groupCount = strlen(representation);
	featureConstruction_GD_numbering(sequence, group, representation);

	int countResult = (groupCount-1) * groupCount / 2;
	int *result = (int*)malloc( countResult * sizeof(int));
	std::memset(result, 0, countResult * sizeof(int));
	for (int k = 0; k < groupCount; k++)
	{
		for(int m = k + 1; m < groupCount; m ++)
		{
			int index = (groupCount * 2 - k - 3) * k / 2 + m - 1;
			for (int n = 0; n < strlen(sequence)-1; n++)
			{
				if ( (sequence[n] == representation[k] && sequence[n+1] == representation[m])
					 || (sequence[n] == representation[m] && sequence[n+1] == representation[k]) )
				{
					result[index]++;
				}
			}
			// printf("result[%d]:%d \n", index, result_2[index]);
		}
	}

	return result;
}

int *featureConstruction_LAAC(char* sequence)
{
	int HEAD_LEN = 30;
	int TAIL_LEN = 30;
	char *sequence_head, *sequence_body, *sequence_tail;
	sequence_head = (char*)malloc( (HEAD_LEN + 1) * sizeof(char));
	std::memset(sequence_head, 0, (HEAD_LEN + 1) * sizeof(char));
	std::memcpy( sequence_head, sequence, HEAD_LEN * sizeof(char) );

	sequence_body = (char*)malloc( (strlen(sequence) - HEAD_LEN - TAIL_LEN + 1) * sizeof(char));
	std::memset(sequence_body, 0, (strlen(sequence) - HEAD_LEN - TAIL_LEN + 1) * sizeof(char));
	std::memcpy( sequence_body, sequence + HEAD_LEN, ( strlen(sequence) - HEAD_LEN - TAIL_LEN ) * sizeof(char) );
	
	sequence_tail = (char*)malloc( (TAIL_LEN + 1) * sizeof(char));
	std::memset(sequence_tail, 0, (TAIL_LEN + 1) * sizeof(char));
	std::memcpy( sequence_tail, sequence + strlen(sequence) - TAIL_LEN, TAIL_LEN * sizeof(char) );

	int *result_head = featureConstruction_AAC(sequence_head);
	int *result_body = featureConstruction_AAC(sequence_body);
	int *result_tail = featureConstruction_AAC(sequence_tail);
	for (int i = 0; i < AMINOACIDS_NUM; i ++) {
		printf("[%c] => %d\n", AMINOACIDS[i], result_head[i] );
	}
	return 0;
}

int *featureConstruction_AAC(char* sequence)
{
	int seqLen = strlen(sequence);
	int *result = (int*)malloc(AMINOACIDS_NUM * sizeof(int));
	std::memset(result, 0, AMINOACIDS_NUM * sizeof(int));
	for (int i = 0; i < AMINOACIDS_NUM; i ++) {
		for (int j = 0; j < seqLen; j ++) {
			if (sequence[j] == AMINOACIDS[i]) {
				result[i]++;
			}
		}
		//if (0 != result[i])
			//printf("[%c] => %d\n", AMINOACIDS[i], result[i] );
		
	}
	return result;
}

double *calcFrequency(char* sequence, char* collection)
{
	int seqLen = strlen(sequence);
	int collectionLen = strlen(collection);
	double *result = (double*)malloc(collectionLen * sizeof(double));
	std::memset(result, 0, collectionLen * sizeof(double));
	for (int i = 0; i < collectionLen; i ++) {
		for (int j = 0; j < seqLen; j ++) {
			if (sequence[j] == collection[i]) {
				result[i]++;
			}
		}
		//if (0 != result[i])
			//printf("[%c] => %d\n", AMINOACIDS[i], result[i] );
	}
	for (int i = 0; i < collectionLen; i ++)
		result[i] =  result[i] / seqLen;
	return result;
}

double *calcSegmentFrequency(char* sequence, char* collection)
{
	int seqLen = strlen(sequence);
	int collectionLen = strlen(collection);
	double *result = (double*)malloc(collectionLen * sizeof(double));
	std::memset(result, 0, collectionLen * sizeof(double));
	for (int i = 0; i < collectionLen; i ++) {
		int segCount = 0;
		for (int j = 0; j < seqLen; j ++) {
			if (sequence[j] == collection[i]) {
				if (segCount==0) result[i]++;
				segCount++;
			} else {

				segCount = 0;
			}
		}
		//if (0 != result[i])
			//printf("[%c] => %d\n", AMINOACIDS[i], result[i] );
	}
	//for (int i = 0; i < collectionLen; i ++)
	//	result[i] =  result[i] / seqLen;
	return result;
}

void calcSegmentStatistics(char* sequence, char* collection, SecondStructureStatistic* result)
{
	int seqLen = strlen(sequence);
	int collectionLen = strlen(collection);
	int segCountTotal = 0;
	for (int i = 0; i < collectionLen; i ++) {
		int segLength = 0;
		int segCount = 0;
		int matchCount = 0;
		double* temp = (double*)malloc(1024 * sizeof(double));
		std::memset(temp, 0, 1024 * sizeof(double));
		for (int j = 0; j < seqLen; j ++) {
			if (sequence[j] == collection[i]) {
				if (segLength == 0) segCount++;
				segLength++;
				matchCount++;
				temp[segCount-1] = segLength;
			} else {
				if (segLength != 0) segLength = 0;
			}
		}
		SecondStructureStatistic* s = &result[i];
		basic_statistics(temp, segCount , &(s->SegemntLengthMin), &(s->SegemntLengthMax), 
			&(s->SegemntLengthAvg), &(s->SegemntLengthSigma));
		delete temp;
		s->SegmentsFreq = segCount;
		s->ElementFreq = (double)matchCount / seqLen;
		segCountTotal += segCount;
	}
	double *distributions = distributionCommon(sequence, collection);
	for (int i = 0; i < collectionLen; i ++) {
		SecondStructureStatistic* s = &result[i];
		s->SegmentsFreq = s->SegmentsFreq/segCountTotal;
		s->Distribution = distributions[i];
	}
}

/*
 * ˵ֲۺ
 */
int *featureConstruction_DistributionSum (char* sequence)
{
	int seqLen = strlen(sequence);
	int *result = (int*)malloc(AMINOACIDS_NUM * sizeof(int));
	std::memset(result, 0, AMINOACIDS_NUM * sizeof(int));
	for (int i = 0; i < AMINOACIDS_NUM; i ++) {
		int matchCount = 0;
		int firstPositionIndex = 0;
		for (int j = 0; j < seqLen; j ++) {
			if (sequence[j] == AMINOACIDS[i]) {
				matchCount ++;
				if (matchCount == 1) {	// ǵһҵ¼״γֵλ
					firstPositionIndex = j;
				} else {
					result[i] += (j - firstPositionIndex);
				}
			}
		}
		//if (0 != result[i])
		//	printf("[%c] => %d\n", AMINOACIDS[i], result[i] );
		
	}
	return result;
}

int *featureConstruction_DAAC(char* sequence)
{
	int seqLen = strlen(sequence);
	int resultLen = AMINOACIDS_NUM * AMINOACIDS_NUM;
	int *result = (int*)malloc(AMINOACIDS_NUM * AMINOACIDS_NUM * sizeof(int));
	std::memset(result, 0, resultLen * sizeof(int));
	for (int i = 0; i < AMINOACIDS_NUM; i ++) {
		for (int k = 0; k < AMINOACIDS_NUM; k ++) {
			int index = i*AMINOACIDS_NUM + k;
			for (int j = 0; j < seqLen; j ++) {
				if (sequence[j] == AMINOACIDS[i] && sequence[j+1] == AMINOACIDS[k]) {
					result[index]++;
				}
			}
			//if (0 != result[index])
				// printf("[%c,%c] => %d\n", AMINOACIDS[i], AMINOACIDS[k], result[index] );
		}
		
	}
	return result;
}

int *featureConstruction_TAAC(char* sequence)
{
	int seqLen = strlen(sequence);
	int resultLen = AMINOACIDS_NUM * AMINOACIDS_NUM * AMINOACIDS_NUM;
	int *result = (int*)malloc(AMINOACIDS_NUM * AMINOACIDS_NUM * AMINOACIDS_NUM * sizeof(int));
	std::memset(result, 0, resultLen * sizeof(int));
	for (int i = 0; i < AMINOACIDS_NUM; i ++) {
		for (int k = 0; k < AMINOACIDS_NUM; k ++) {
			for (int l = 0; l < AMINOACIDS_NUM; l ++) {
				int index = i*AMINOACIDS_NUM + k*AMINOACIDS_NUM + l;
				for (int j = 0; j < seqLen; j ++) {
					if (sequence[j] == AMINOACIDS[i] && sequence[j+1] == AMINOACIDS[k] && sequence[j+2] == AMINOACIDS[l]) {
						result[index]++;
					}
				}
				//if (0 != result[index])
					//printf("[%c,%c,%c] => %d\n", AMINOACIDS[i], AMINOACIDS[k], AMINOACIDS[l], result[index] );
			}
		}
		
	}
	return result;
}


double *featureConstruction_PSEAAC(char* sequence)
{
	const int ETA_MAX = PSEAAC_ETA_MAX;
	int L = strlen(sequence);
	int *t_count = featureConstruction_AAC(sequence);
	double t[AMINOACIDS_NUM];
	std::memset(t, 0, AMINOACIDS_NUM * sizeof(double));
	for (int i = 0; i < AMINOACIDS_NUM; i++) {
		t[i] = (float)t_count[i] / L;
	}
	double delta[ETA_MAX];
	std::memset(delta, 0, ETA_MAX * sizeof(double));
	for (int eta = 1; eta <= ETA_MAX; eta++) {
		for (int i = 0; i < L - eta; i ++) {
			delta[eta-1] += Correlation_PSEAAC(sequence[i], sequence[i + eta]);
		}
		delta[eta-1] /= (L - eta);
	}
	// for (int j = 0; j < 10; j ++) printf("delta[%d]=%f \n", j+1, delta[j]);
	double *q = (double*)malloc((AMINOACIDS_NUM+ETA_MAX) * sizeof(double));
	std::memset(q, 0, (AMINOACIDS_NUM+ETA_MAX) * sizeof(double));
	double MU = 0.5;
	for (int k = 0; k < AMINOACIDS_NUM + ETA_MAX; k ++)		
	{
		double num = 0;
		double den = 0;
		den += 1;
		for (int j = 0; j < ETA_MAX; j ++) {
			den += MU * delta[j];
		}
		
		if (k < AMINOACIDS_NUM)
		{
			num = t[k];
		}
		else
		{
			num = MU * delta[k-AMINOACIDS_NUM];
		}
		q[k] = num / den;
	}
	
	//for (i =0; i < AMINOACIDS_NUM+ETA_MAX; i ++)
		//printf("q[%d]=%f \n", i, q[i]);

	return q;
}

int GetIndexInAMINOACIDS(char c)
{
	for (int i = 0; i < AMINOACIDS_NUM; i ++)
		if (c == AMINOACIDS[i]) return i;
	return -1;
}

double Correlation_PSEAAC(char qi, char qj)
{
	int a = GetIndexInAMINOACIDS(qi);
	int b = GetIndexInAMINOACIDS(qj);

	double sum = 0;
	for (int i = 0; i < PSEAAC_PROP_NUM; i++) {
		sum += pow( StandardConversion_PSEAAC(i, b) - StandardConversion_PSEAAC(i, a), 2);
	}
	return sum / PSEAAC_PROP_NUM;
}

double StandardConversion_PSEAAC(int index, int i)
{
	double sum = 0;
	for (int j = 0; j < AMINOACIDS_NUM; j ++) sum += PSEAAC_PROP[index][j];
	sum /= AMINOACIDS_NUM;
	
	double num = PSEAAC_PROP[index][i] - sum;
	double den = 0;
	for (int k = 0; k < AMINOACIDS_NUM; k ++) {
		den += pow( PSEAAC_PROP[index][k] - sum, 2);
	}
	den = sqrt(den / 20);
	return num / AMINOACIDS_NUM;
}


/*
 *  ˵fastaʽļеݿ
 *  
 *        filename fastaʽļ
 *  أ
 *	      и
 *
 */
int import_sequences(const char *filename, const char* seqclass, ADOConn* conn)
{
	FILE *stream;
    char line[szSTR];
	char acc_id[10];
	char sequence[maxSeqLen];

	if ( (stream = fopen(filename, "r")) == NULL) {
        fprintf(stderr,"Cannot open output file.\n");
        return -1;
    }
	int count = 0;
	std::memset(sequence, 0, maxSeqLen);
	while (!feof(stream)) {
		std::memset(line, 0, szSTR);
		fgets(line, szSTR-1, stream);
		// printf(line);
		if (line[0] == '>' || feof(stream)) {
			count ++;
			if (count != 1) {
				char sql[20000];
				char* format = "INSERT INTO CORE_SEQS(SEQCLASS, ACC_ID, SEQUENCE) VALUES('%s', '%s', '%s')";
				sprintf_s(sql, format, seqclass, acc_id, sequence);
				conn->ExecuteSQL(sql);
				std::memset(sequence, 0, maxSeqLen);
			}
			if (!feof(stream)) {
				if (line[strlen(line)-1] == '\n') line[strlen(line)-1] = '\0';
				strcpy_s(acc_id, line+sizeof(char));
			}			
		} else {
			if (line[strlen(line)-1] == '\n') line[strlen(line)-1] = '\0';
			strcat_s(sequence, line);
		}
	}
	
    fclose(stream);
	printf("%s import finished, total: %d\n", filename, count-1);

	return count;
}

int import_sequences_cats(const char *filename, const char* seqclass, ADOConn* conn)
{
	FILE *stream;
	char line[szSTR];
	char acc_id[10];
	char sequence[maxSeqLen];

	if ( (stream = fopen(filename, "r")) == NULL) {
		fprintf(stderr,"Cannot open output file.\n");
		return -1;
	}
	int count = 0;
	int cat_id = 0;
	std::memset(sequence, 0, maxSeqLen);
	while (!feof(stream)) {
		std::memset(line, 0, szSTR);
		fgets(line, szSTR-1, stream);
		if (line[0] == '(') {
			cat_id++;
			continue;
		}
		// printf(line);
		if (line[0] == '>' || feof(stream)) {
			count ++;
			if (count != 1) {
				char sql[20000];
				char* format = "INSERT INTO TEMP_SEQS(SEQCLASS, ACC_ID, SEQUENCE, CAT) VALUES('%s', '%s', '%s', '%d')";
				sprintf_s(sql, format, seqclass, acc_id, sequence, cat_id);
				conn->ExecuteSQL(sql);
				std::memset(sequence, 0, maxSeqLen);
			}
			if (!feof(stream)) {
				if (line[strlen(line)-1] == '\n') line[strlen(line)-1] = '\0';
				strcpy_s(acc_id, line+sizeof(char));
			}			
		} else {
			if (line[strlen(line)-1] == '\n') line[strlen(line)-1] = '\0';
			strcat_s(sequence, line);
		}
	}

	fclose(stream);
	printf("%s import finished, total: %d\n", filename, count-1);

	return count;
}

int SoapClient_Psipred(const char* serviceName, void *pRequest, void *pResponse)
{
	CoInitialize(NULL);
	ISoapSerializerPtr Serializer;
	ISoapReaderPtr Reader;
	ISoapConnectorPtr Connector;

	// ӷ
	Connector.CreateInstance(__uuidof(HttpConnector30));
	Connector->Property["EndPointURL"] = "http://bioinf.cs.ucl.ac.uk/psipred_api/action";
	Connector->Connect();

	// Ϣ
	Connector->Property["SoapAction"] = serviceName;
	Connector->BeginMessage();

	// SoapSerializer
	Serializer.CreateInstance(__uuidof(SoapSerializer30));

	// 
	Serializer->Init(_variant_t((IUnknown*)Connector->InputStream));
	
	// SOAPϢ
	Serializer->StartEnvelope("","","");
	Serializer->StartBody("");	
	Serializer->StartElement(serviceName,"","","");

	if ("PsipredSubmit" == serviceName) 
	{
		PsipredSubmitRequest* pReq = (PsipredSubmitRequest*)pRequest;
		Serializer->StartElement("sequence","","","");
		Serializer->WriteString(pReq->sequence.c_str());
		Serializer->EndElement();

		Serializer->StartElement("email","","","");
		Serializer->WriteString(pReq->email.c_str());
		Serializer->EndElement();

		Serializer->StartElement("name","","","");
		Serializer->WriteString(pReq->name.c_str());
		Serializer->EndElement();

		Serializer->StartElement("complex","","","");
		Serializer->WriteString(pReq->complex.c_str());
		Serializer->EndElement();

		Serializer->StartElement("membrane","","","");
		Serializer->WriteString(pReq->membrane.c_str());
		Serializer->EndElement();

		Serializer->StartElement("coil","","","");
		Serializer->WriteString(pReq->coil.c_str());
		Serializer->EndElement();

		Serializer->StartElement("msa_control","","","");
		Serializer->WriteString(pReq->msa_control.c_str());
		Serializer->EndElement();
	}
	else if ("PsipredResult" == serviceName)
	{
		PsipredResultRequest* pReq = (PsipredResultRequest*)pRequest;
		Serializer->StartElement("job_id","","","");
		Serializer->WriteString(pReq->job_id.c_str());
		Serializer->EndElement();
	}
	else if ("DompredSubmit" == serviceName) 
	{
		DompredSubmitRequest* pReq = (DompredSubmitRequest*)pRequest;
		Serializer->StartElement("sequence","","","");
		Serializer->WriteString(pReq->sequence.c_str());
		Serializer->EndElement();

		Serializer->StartElement("email","","","");
		Serializer->WriteString(pReq->email.c_str());
		Serializer->EndElement();

		Serializer->StartElement("name","","","");
		Serializer->WriteString(pReq->name.c_str());
		Serializer->EndElement();

		Serializer->StartElement("eval","","","");
		Serializer->WriteString(pReq->eval.c_str());
		Serializer->EndElement();

		Serializer->StartElement("iterations","","","");
		Serializer->WriteString(pReq->iterations.c_str());
		Serializer->EndElement();

		Serializer->StartElement("secpro","","","");
		Serializer->WriteString(pReq->secpro.c_str());
		Serializer->EndElement();

		Serializer->StartElement("pp","","","");
		Serializer->WriteString(pReq->pp.c_str());
		Serializer->EndElement();
	}
	else if ("DompredResult" == serviceName)
	{
		DompredResultRequest* pReq = (DompredResultRequest*)pRequest;
		Serializer->StartElement("job_id","","","");
		Serializer->WriteString(pReq->job_id.c_str());
		Serializer->EndElement();
	}

	Serializer->EndElement();
	Serializer->EndBody();
	Serializer->EndEnvelope();

	// Ϣ
	
	try {
		Connector->EndMessage();
		// ȡӦ
		Reader.CreateInstance(__uuidof(SoapReader30));
		// 
		Reader->Load(_variant_t((IUnknown*)Connector->OutputStream), "");
		//printf("Answer: %s\n",(const char*) Reader->RpcResult->text);
	} catch (_com_error x) {
		cout << "SOAP request error:" << endl;
		return -1;
	}
		
	// ý
	if (Reader->GetDom()->getElementsByTagName("message")->Getlength() > 0)
	{
		//cout << Reader->GetDom()->Getxml() << endl;

		if ("PsipredSubmit" == serviceName) 
		{
			PsipredSubmitResponse *pRes = (PsipredSubmitResponse*)pResponse;
			pRes->message = Reader->GetDom()->getElementsByTagName("message")->Getitem(0)->text;
			pRes->job_id = Reader->GetDom()->getElementsByTagName("job_id")->Getitem(0)->text;
			pRes->state = Reader->GetDom()->getElementsByTagName("state")->Getitem(0)->text;
		}
		else if ("PsipredResult" == serviceName)
		{
			PsipredResultResponse * pRes = (PsipredResultResponse*)pResponse;
			pRes->message = Reader->GetDom()->getElementsByTagName("message")->Getitem(0)->text;
			pRes->job_id = Reader->GetDom()->getElementsByTagName("job_id")->Getitem(0)->text;
			pRes->state = Reader->GetDom()->getElementsByTagName("state")->Getitem(0)->text;
			pRes->psipred_postscript = Reader->GetDom()->getElementsByTagName("psipred_postscript")->Getitem(0)->text;
			pRes->psipred_results = Reader->GetDom()->getElementsByTagName("psipred_results")->Getitem(0)->text;
		}
		else if ("DompredSubmit" == serviceName)
		{
			DompredSubmitResponse *pRes = (DompredSubmitResponse*)pResponse;
			pRes->message = Reader->GetDom()->getElementsByTagName("message")->Getitem(0)->text;
			pRes->job_id = Reader->GetDom()->getElementsByTagName("job_id")->Getitem(0)->text;
			pRes->state = Reader->GetDom()->getElementsByTagName("state")->Getitem(0)->text;
		}
		else if ("DompredResult" == serviceName)
		{
			cout << Reader->GetDom()->Getxml() << endl;
			DompredResultResponse * pRes = (DompredResultResponse*)pResponse;
			pRes->message = Reader->GetDom()->getElementsByTagName("message")->Getitem(0)->text;
			pRes->job_id = Reader->GetDom()->getElementsByTagName("job_id")->Getitem(0)->text;
			pRes->state = Reader->GetDom()->getElementsByTagName("state")->Getitem(0)->text;
			pRes->dompred_graph = Reader->GetDom()->getElementsByTagName("dompred_graph")->Getitem(0)->text;
			pRes->dompred_output = Reader->GetDom()->getElementsByTagName("dompred_output")->Getitem(0)->text;
			pRes->psiblast_output = Reader->GetDom()->getElementsByTagName("psiblast_output")->Getitem(0)->text;
			pRes->psiblast_table = Reader->GetDom()->getElementsByTagName("psiblast_table")->Getitem(0)->text;
			pRes->domssea_table = Reader->GetDom()->getElementsByTagName("domssea_table")->Getitem(0)->text;
			pRes->psipred_ps = Reader->GetDom()->getElementsByTagName("psipred_ps")->Getitem(0)->text;
		}
	}
	
	Serializer.Release();  
	Connector.Release();  
	Reader.Release();  
	CoUninitialize(); 
	return 1;
}


/*
 * ˵ֶΪɵǿת
 *
 */
_bstr_t GetCollect(_RecordsetPtr rs, const char* columnName)
{
	_bstr_t result = "";
	_variant_t t = rs->GetCollect(columnName); 
	if(t.vt!=VT_NULL && t.vt!=VT_EMPTY)
		result = (_bstr_t)t;
	return result;
}

int featureConstruction_Disorder(char* sequence, DisorderStatistic *statistics)
{
	char szAppPath[MAX_PATH]; 
	GetModuleFileName(NULL, szAppPath, MAX_PATH);
	(strrchr(szAppPath, '\\'))[1] = 0;
	stringstream tempfastaPath;
	stringstream tempresultPath;
	stringstream vsl2cmd;
	tempfastaPath << szAppPath << "temp.fasta";
	tempresultPath<< szAppPath << "temp.result";
	vsl2cmd <<"java -classpath "<< szAppPath << " VSL2 -s:" << tempfastaPath.str() << " >> " << tempresultPath.str();

	int sequenceLen = strlen(sequence);
	// 1дfastaļ
	ofstream fastaFile;
	fastaFile.open(tempfastaPath.str().c_str(), ios::ate);
	if(!fastaFile.fail())
	{
		fastaFile<<sequence<<endl;
		fastaFile.close();
	} 
	else
	{
		cout<<"޷ʱfastaļ"<<endl;
		return 0;
	}
	// 2սļVSL2ļ
	ofstream resultFile;
	resultFile.open(tempresultPath.str().c_str(), ios::ate);
	if(!resultFile.fail())
	{
		resultFile<<endl;
		resultFile.close();
	} 
	else
	{
		cout<<"޷resultļ"<<endl;
		return 0;
	}
	//cout << vsl2cmd.str() << endl;
	system(vsl2cmd.str().c_str());
	// 3ȡļϢȡ
	ifstream fin( tempresultPath.str().c_str() );
    string s;
	bool startSegInfo = false;
	list<Segment> segments;
	bool startDetail = false;
	double *x = (double*)malloc(sequenceLen * sizeof(double));
	std::memset(x, 0, sequenceLen * sizeof(double));
	int count = 0;
    while ( std::getline(fin,s) )
    {   
		if ( s == "Predicted Disordered Regions:") 
		{
			startSegInfo = true;
			continue;
		}
		
		if ( s == "----------------------------------------") 
		{
			startDetail = true;
			continue;
		}
		if (startSegInfo) {
			if (s.length() >= 3)	{
				int a, b;
				sscanf_s(s.c_str(), "%d-%d", &a, &b);
				Segment seg;
				seg.start = a;
				seg.end = b;
				segments.push_back(seg);
			} else {
				startSegInfo = false;
			}
			continue;
		}
		if (startDetail) {
			if (s.at(0) != '=') {
				x[count++] = atof(s.substr(s.find_first_of(".")-1, 8).c_str());
			} else {
				startSegInfo = false;
			}
		}
    }
	// 4ͳƽ
	double temp1,temp2 = 0;
	basic_statistics(x, sequenceLen, &temp1, &temp2, &(statistics->average), &(statistics->sigma));
	
	list<int> disorderedLens;
	list<int> orderedLens;
	list<Segment>::iterator iter;
	iter=segments.begin();
	Segment segPrev;
	//segPrev.start = 0;
	//segPrev.end = 0;

	while(iter!=segments.end())
	{
		Segment seg = *iter;
		if ( iter != segments.begin() ) 
		{
			orderedLens.push_back(seg.start - segPrev.end - 1);
		}
		else
		{
			if ( seg.start != 1 ) orderedLens.push_back(seg.start - 1);
		}
		disorderedLens.push_back(seg.end - seg.start + 1);
		segPrev = seg;
		iter++;
	}
	if (segPrev.end != sequenceLen) orderedLens.push_back(sequenceLen - segPrev.end);

	statistics->DisorderedSegmentLengthMax = 0;
	statistics->DisorderedSegmentLengthMin = 100000;
	statistics->OrderedSegmentLengthMax = 0;
	statistics->OrderedSegmentLengthMin = 100000;
	std::list<int>::iterator it;
	for (it = disorderedLens.begin(); it != disorderedLens.end(); it++)
	{
 		int v = *it;
		if (v > statistics->DisorderedSegmentLengthMax) 
			statistics->DisorderedSegmentLengthMax= v;
		if (v < statistics->DisorderedSegmentLengthMin) 
			statistics->DisorderedSegmentLengthMin= v;
	}
	for (it = orderedLens.begin(); it != orderedLens.end(); it++)
	{
		int v = *it;
		if (v > statistics->OrderedSegmentLengthMax) 
			statistics->OrderedSegmentLengthMax= v;
		if (v < statistics->OrderedSegmentLengthMin) 
			statistics->OrderedSegmentLengthMin= v;
	}

	statistics->DisorderedSegmentLengthMax /= sequenceLen;
	statistics->DisorderedSegmentLengthMin /= sequenceLen;
	statistics->OrderedSegmentLengthMax /= sequenceLen;
	statistics->OrderedSegmentLengthMin /= sequenceLen;
	statistics->DisorderedSegmentsNum = disorderedLens.size();
	statistics->OrderedSegmentsNum = orderedLens.size();

	return 1;
}

double *SC_ABTransitions(char* sequence, char **group, char* representation)
{
	int seqLen = strlen(sequence);
	int groupCount = strlen(representation);
	int countResult = (groupCount-1) * groupCount / 2;
	int *transitionsMatchCount = featureConstruction_GD_transitions(sequence, group, representation);
	double *transitionsFrequency = (double*)malloc(countResult * sizeof(double));
	std::memset(transitionsFrequency, 0, countResult * sizeof(double));
	for (int i = 0; i < countResult; i ++) {
		transitionsFrequency[i] = (double)transitionsMatchCount[i] / seqLen;
	}
	return transitionsFrequency;
}

double *distributionCommon(char* sequence, char* collection)
{
	int seqLen = strlen(sequence);
	int collectionLen = strlen(collection);

 	int *countAmino = (int*)malloc(collectionLen * sizeof(int));
	int *distanceSum = (int*)malloc(collectionLen * sizeof(int));
	double *eta = (double*)malloc(collectionLen * sizeof(double));
	double *distribution = (double*)malloc(collectionLen * sizeof(double));
	std::memset(countAmino, 0, collectionLen * sizeof(int));
	std::memset(distanceSum, 0, collectionLen * sizeof(int));
	std::memset(eta, 0, collectionLen * sizeof(double));
	std::memset(distribution, 0, collectionLen * sizeof(double));
	for (int i = 0; i < collectionLen; i ++) {
		int matchCount = 0;
		int firstPositionIndex = 0;
		for (int j = 0; j < seqLen; j ++) {
			if (sequence[j] == collection[i]) {
				matchCount ++;
				if (matchCount == 1) {	// ǵһҵ¼״γֵλ
					firstPositionIndex = j;
				} else {
					distanceSum[i] += (j - firstPositionIndex);
				}
			}
		}
		countAmino[i] = matchCount;
		if (0 != countAmino[i]) eta[i] =  (double)distanceSum[i] / countAmino[i];
	}


	for (int i = 0; i < collectionLen; i ++) {
		int matchCount = 0;
		int firstPositionIndex = 0;
		if (0 != countAmino[i]) {
			for (int j = 0; j < seqLen; j ++) {
				int t = 0;
				if (sequence[j] == collection[i]) {
					matchCount ++;
					if (matchCount == 1) {	// ǵһҵ¼״γֵλ
						firstPositionIndex = j;
					}
					t = j - firstPositionIndex;
					distribution[i] += pow( t-eta[i], 2 ) / countAmino[i];
				}
			}
		}
		//if (0 != distribution[i])
		//	printf("[%c] => %f\n", AMINOACIDS[i], distribution[i] );
	}

	return distribution;
}

double *SC_distributionOfAminoAcid(char* sequence)
{
	char* strAMINOACIDS = AMINOACIDS;
	strAMINOACIDS[AMINOACIDS_NUM] = '\0';
	return distributionCommon(sequence, strAMINOACIDS);
}

double *SC_entropyOfComposition(char* sequence)
{
	int seqLen = strlen(sequence);
	int *resultAmino = featureConstruction_AAC(sequence);
	double *H = (double*)malloc(2 * sizeof(double));
	std::memset(H, 0, 2 * sizeof(double));

	double HAmino = 0;
	for (int i = 0; i < AMINOACIDS_NUM; i++) {
		if (resultAmino[i] != 0) {
			double pi = (double)resultAmino[i] / seqLen;
			HAmino += -pi * log(pi);
		}
	}

	double HDipeptide  = 0;
	int *resultDipeptide = featureConstruction_DAAC(sequence);
	for (int j = 0; j < AMINOACIDS_NUM*AMINOACIDS_NUM; j++) {
		if (resultDipeptide[j] != 0) {
			double pj = (double)resultDipeptide[j] / (seqLen-1);
			HDipeptide += -pj * log(pj);
		}
	}

	H[0] = HAmino;
	H[1] = HDipeptide;

	// printf("HAmino: %f, HDipeptide: %f \n", H[0], H[1]);

	return H;
}


float featureConstruction_RepetitiveResidue(char* sequence)
{
	float result = 0;
	int seqLen = strlen(sequence);

	for (int i = 0; i <= seqLen-2; i ++)
	{
		int M = 0;
		for (int j = 0; j < AMINOACIDS_NUM; j++)
		{
			int temp = 0;
			for (int k = 0; k < seqLen-i-1; k ++)
				if (sequence[k] == AMINOACIDS[j] && sequence[k] == sequence[k+i+1])
					temp ++;
			if (temp > M) M = temp;
		}
		result += M;
	}
		
	return result/seqLen;
}


// liujin
double *featureConstruction_Composition(char* sequence, const char* specified)
{
	int seqLen = strlen(sequence);
	int specLen = strlen(specified);

	double *result;
	result = (double*)malloc(specLen * sizeof(double));
	std::memset(result, 0, specLen * sizeof(double));

	for (int i = 0; i < seqLen; i++)
	{
		for (int j = 0; j < specLen; j++)
		{
			if (sequence[i] == specified[j])
			{
				result[j] ++;
				break;
			}
		}
	}

	for (int j = 0; j < specLen; j++)
		result[j] = result[j] / seqLen;

	return result;
}

float featureConstruction_Aliphatic_Residue(char* sequence, const char* group)
{
	float result = 0;
	int seqLen = strlen(sequence);
	int groupLen = strlen(group);

	for (int i = 0; i < seqLen; i++)
	{
		for (int j = 0; j < groupLen; j++)
		{
			if (sequence[i] == group[j])
			{
				result ++;
				break;
			}
		}
	}

	return result/seqLen;
}

float featureConstruction_Molecular_Weight(char* sequence)
{
	float result = 0;
	int seqLen = strlen(sequence);

	for (int i = 0; i < seqLen; i++)
	{
		result += PSEAAC_PROP[24][GetIndexInAMINOACIDS(sequence[i])];
	}

	return result;
}

int featureConstruction_GXY_Repeats(char* sequence)
{
	int result = 0;
	int seqLen = strlen(sequence);

	for (int i = 0; i < seqLen-5; i ++)
	{
		if (i<3)
		{

			if (sequence[i] == 'G' && sequence[i+3] == 'G')
				result++;
		}
		else
		{
			if (sequence[i] == 'G' && sequence[i-3] != 'G' && sequence[i+3] == 'G')
				result++;
		}
	}

	return result;
}

double *featureConstruction_DWT(char* sequence, int propIndex)
{

	if (!bInitialized_dwt) {

		// ʼ
		if( ! mclInitializeApplication(NULL,0) )
		{
			fprintf(stderr, "Could not initialize the application.\n");
			exit(1);
		}
		// ʼ
		if (! libdwtInitialize() )
		{
			fprintf(stderr,"Could not initialize the library.\n");
			exit(1);
		}
		bInitialized_dwt = true;
	}
	
	int sequenceLen = strlen(sequence);
	double *x = (double*)malloc(sequenceLen * sizeof(double));
	std::memset(x, 0, sequenceLen * sizeof(double));
	for (int i = 0; i < sequenceLen; i ++) {
		int acidIndex = GetIndexInAMINOACIDS(sequence[i]);
		x[i] = PSEAAC_PROP[propIndex][acidIndex];
	}
	// double x[] = {1,2,3,4,5,6,7,8,9};
	char *varargin = "Db4";
	mxArray* result[DWT_LAYER_NUM][2] = {NULL};

	// һ
	dwt(x, sequenceLen, varargin, &(result[0][0]), &(result[0][1]));

	for (int i = 0; i < DWT_LAYER_NUM-1; i++) {

		double *dataCA = mxGetPr(result[i][0]);
		double *dataCD = mxGetPr(result[i][1]);
		int lenthCA = mxGetN(result[i][0]);
		int lenthCD = mxGetN(result[i][1]);

		mxArray *temp1=NULL;
		mxArray *temp2=NULL;
		char *varargin = "Db4";
		dwt(dataCA, lenthCA, varargin, &(result[i+1][0]), &temp1);
		dwt(dataCD, lenthCD, varargin, &temp2, &(result[i+1][1]));
	}
	
	// ͳƽ
	
	double *statistics = (double*)malloc(DWT_PROP_NUM * sizeof(double));
	std::memset(statistics, 0, DWT_PROP_NUM * sizeof(double));
	double temp1,temp2 = 0;
	basic_statistics(x, sequenceLen, &temp1, &temp2, &(statistics[0]), &(statistics[1]));

	for (int i = 0; i < DWT_LAYER_NUM; i++) {
		// ʾ mxArray 
		//display(result[i][0],"CA");
		//display(result[i][1],"CD");
		
		merge_and_statistics(result[i][0], result[i][1], 
			&(statistics[2+i*4]), &(statistics[2+i*4+1]),		// Сֵֵ
			&(statistics[2+i*4+2]), &(statistics[2+i*4+3])	// ƽֵ
		);
		
	}

	//for (i=0;i<18;i++) {
		//printf("% 4.2f \t",statistics[i]);
	//}
	//printf("\n");
	

	//delete x;
	//delete result;
	// ٶ
//	for (i = 0; i < 4; i++) {
//		mxDestroyArray(result[i][0]);
//		mxDestroyArray(result[i][1]);
//	}

	return statistics;
}


void merge_and_statistics(const mxArray* CA, const mxArray* CD, 
			double *ymin, double *ymax, double *ymean, double *ysigma)
{
	// ϲCACDһ飬ϲָ븳yϲ󳤶Ϊny
	double *dataCA = mxGetPr(CA);
	double *dataCD = mxGetPr(CD);
	int lenthCA = mxGetN(CA);
	int lenthCD = mxGetN(CD);
	int ny = lenthCA+lenthCD;
	double *y = new double[ny];
	for (int i=0; i<lenthCA; i++) {
		y[i] = dataCA[i];
	}
	for (int i=0;i<lenthCD; i++) {
		y[lenthCA+i] = dataCD[i];
	}
	//memcpy(y, dataCA, lenthCA * sizeof(double));
	//memcpy(y+lenthCA * sizeof(double), dataCD, lenthCD * sizeof(double));
	
	// ֵСֵƽֵ
	basic_statistics(y, ny, ymin, ymax, ymean, ysigma);
	delete []y;
}


/* ----------------------------------------------------------
 * basic_statistics()
 * input y[N]
 * output y_min, y_max, y_mean, y_sigma
 * ----------------------------------------------------------*/
void basic_statistics(double *y, int N, double *ymin, double *ymax, double *ymean, double *ysigma)
{
	int i = 0;
	double yd=0,yu=0,ym=0,ys=0,dy=0;
	double sum = 0;

	yd = y[0]; yu= y[0];
	sum = 0.0;
	for (i=0;i<N;i++){
		sum = sum + y[i];
		if (y[i] > yu) yu = y[i];
		if (y[i] < yd) yd = y[i];
	}
	if (N !=0) ym = (double) (  sum / (double) N );
	*ymin = yd;
	*ymax = yu;
	*ymean = ym;

	sum = 0.0;
	for (i=0;i<N;i++){
		dy = y[i] - ym;
		sum = sum + dy * dy;
	};
	if (N>1) ys = (double)(  sum / (double) (N-1) );      
	*ysigma = (double) ys;
}


/**
 *
 * x	
 * nx	xеԪظ
 *
 */
void dwt(double *x, int nx, char *varargin, mxArray** CA, mxArray** CD)
{
	
	//  DLL  mxArray 
	mxArray *X,*VARARGIN;
	//  mxArray ڴ
	X = mxCreateDoubleMatrix(1,nx,mxREAL);
    VARARGIN = mxCreateString(varargin);
	//  mxArray ֵ
	std::memcpy(mxGetPr(X),x,nx*sizeof(double));
	//  DLL עĽӿǲͬ
	mlfDwt(2,CA,CD,X,VARARGIN) ;
	// ͷ mxArray ռõڴ
	// עڴڵ DLL з
	mxDestroyArray(X);
	mxDestroyArray(VARARGIN);
	
}


// ʾ
void display(const mxArray* in, const char* name)
{
	int i,j,r,c;
	double *data;
	data = mxGetPr(in);
	r = mxGetM(in);
	c = mxGetN(in);
	printf("%s = \n",name);
	for(i=0;i<r;i++)
	{
		printf("\t");
		for(j=0;j<c;j++)
		printf("% 4.2f \t",data[j*r+i]);
		printf("\n");
	}
	printf("\n");
}
