package cn.edu.sdu.virion.application;

import cn.edu.sdu.virion.common.Constants;
import cn.edu.sdu.virion.feature.selection.BiBayes;
import cn.edu.sdu.virion.feature.selection.CTD;
import cn.edu.sdu.virion.feature.selection.Join;
import cn.edu.sdu.virion.feature.selection.PsePP;
import cn.edu.sdu.virion.feature.selection.PsePSSM2;



/**
 * Ӧó
 * @author Administrator
 *
 * JOBID {JOBID} TASK {TASK}
 */
public class Application {
	
	public static void main(String[] args) throws Exception
	{
		Constants.DB_URL = "jdbc:sqlserver://127.0.0.1;databaseName=virion";	// ݿַ
		
		String jobid = args[1];
		String action = args[3];
		
		String tableName = "WEB_SEQS";
		String strWhere = String.format("JOBID='%s'", jobid);
		
		if (action.equals("MAIN")) {
			
			/**
			 * CTDȡ
			 */
			cn.edu.sdu.virion.feature.extraction.CTD.updateWebSeqs(jobid);
			
			/**
			 * BiBayesȡ
			 */
			cn.edu.sdu.virion.feature.extraction.BiBayes.updateWebSeqs(jobid);
			
			/**
			 * PseAACȡ
			 */
			cn.edu.sdu.virion.feature.extraction.PsePP.updateWebSeqs(jobid);
			
			/**
			 * PSSMȡ
			 */
			cn.edu.sdu.virion.feature.extraction.PsePSSM.updateFeaturesByOwn(tableName, strWhere);
////			cn.edu.sdu.virion.feature.extraction.PsePSSM.updateBLAST_1_JOBID(tableName, strWhere);
////		}
////		else if (action.equals("BLAST_2_JOBID")) {
////			cn.edu.sdu.virion.feature.extraction.PsePSSM.updateBLAST_2_JOBID(tableName, strWhere);
////		}
////		else if (action.equals("BLAST_3_JOBID")) {
////			cn.edu.sdu.virion.feature.extraction.PsePSSM.updateBLAST_3_JOBID(tableName, strWhere);
////		}
////		else if (action.equals("BLAST_3_RESULT")) {
////			cn.edu.sdu.virion.feature.extraction.PsePSSM.updateFeatures(tableName, strWhere);
//		} else if (action.equals("TEST")) {
			/**
			 * ģͲύ
			 */
			CTD ctd = new CTD();
			ctd.testWebSeqsUseModel(jobid);
			
			BiBayes b = new BiBayes();
			b.testWebSeqsUseModel(jobid);
			
			PsePP p = new PsePP();
		    p.testWebSeqsUseModel(jobid);
			
			PsePSSM2 p2 = new PsePSSM2();
			p2.testWebSeqsUseModel(jobid);
			
			Join j = new Join();
			j.testWebSeqsUseModel(jobid);
		}
		

		/**
		 * ģļ
		 */
		
//		CTD ctd = new CTD();
//		ctd.generateModelFile();
//		
//		BiBayes b = new BiBayes();
//		b.generateModelFile();
//		
//		PsePP p = new PsePP();
//		p.generateModelFile();
//		
//		PsePSSM2 p2 = new PsePSSM2();
//		p2.generateModelFile();
//		
//		Join j = new Join();
//		j.generateModelFile();
	}

//	public static void main(String[] args) throws Exception {
		
//		CTD ctd = new CTD();
//		ctd.generateModelFile();
//		
//		BiBayes b = new BiBayes();
//		b.generateModelFile();
//		
////		PsePP p = new PsePP();
////		p.generateModelFile();
//		
//		PsePSSM2 p2 = new PsePSSM2();
//		p2.generateModelFile();
//		
//		Join j = new Join();
//		j.generateModelFile();
		
		
//	}
	
	
	
}
 