package cn.edu.sdu.virion.common;

import weka.classifiers.Classifier;
import wlsvm.WLSVM;


/**
 * 
 * @author Administrator
 *
 */
public final class Constants {
	
	/**
	 * ݿ
	 */
    public static String DB_DRIVER = "com.microsoft.sqlserver.jdbc.SQLServerDriver"; 	// ݿ
    public static String DB_URL = "jdbc:sqlserver://127.0.0.1;databaseName=virion";	// ݿַ
    public static String DB_USER = "sa"; 			// ݿû
    public static String DB_PSWD = "i2no!@#$"; 		// ݿû
    
    /**
     * ݿ
     */
    public static String TABLE_NAME_SEQS = "CDHIT_SEQS";
	
    /**
     * 20ְŶ
     */
	public static char[] AMINOACIDS = 
		{
		'A', 'C', 'D', 'E', 'F',
		'G', 'H', 'I', 'K', 'L',
		'M', 'N', 'P', 'Q', 'R',
		'S', 'T', 'V', 'W', 'Y'
	};
	
	/**
	 * 鶨弯
	 */
	public static String[][] COMPOSITION_GROUP_COLLECTION = {
		{"G", "IVFYW", "ALMEQRK", "P", "NDHSTC"},
		{"RDENQKH", "LIVAMF", "STYW", "P", "G", "C"},
		{"AILVGP", "DE", "HKR", "FWY", "NQ", "ST", "CM"},
		{"G", "IV", "FYW", "ALM", "EQRK", "P", "ND", "HSTC"},
		{"G", "IV", "FYW", "ALM", "EQRK", "P", "ND", "HS", "TC"},
		{"FWY", "DE", "H", "K", "R", "C", "M", "QN", "ST", "AGILVP"},
		{"G", "IV", "FYW", "A", "LM", "EQRK", "P", "ND", "HS", "T", "C"},
		{"A", "R", "N", "D", "C", "Q", "E", "G", "H", "I", "L", "K", "M", "F", "P", "S", "T", "W", "Y", "V"},	// δ
	};
	
	public static String[] COMPOSITION_GROUP_LEADER_COLLECTION = {
		"GIAPN",
		"RLSPGC",
		"ADHFNSC",
		"GIFAEPNH",
		"GIFAEPNHT",
		"FDHKRCMQSA",
		"GIFALEPNHTC",
		"ARNDCQEGHILKMFPSTWYV",	// δ	
	};
	
	/**
	 * CTD㷨еķ
	 */
	public static String[] CTD_COMPOSITION_GROUP = COMPOSITION_GROUP_COLLECTION[0];
	public static String CTD_COMPOSITION_GROUP_LEADER = COMPOSITION_GROUP_LEADER_COLLECTION[0];
	
	
	/**
	 * CTD㷨еĹؼλö
	 */
	public static float[] CTD_DISTRIBUTION_POSITIONS = {
		(float)0, (float) 0.25, (float) 0.5, (float) 0.75, (float) 1.00
	};
	
	/**
	 * BiBayes㷨ͷβĳȶ
	 */
	public static int[] BIBAYES_HEADFOOT_LEN_COLLECTION = {15,16,17,18,19,20,21,22,23,24,25};
	public static int BIBAYES_HEADFOOT_LEN = BIBAYES_HEADFOOT_LEN_COLLECTION[0];
	
	/**
	 * ֱʶ
	 */
	public static int SEQCLASS_POSITIVE = 1;
	public static int SEQCLASS_NEGATIVE = -1;

	/**
	 * BLAST web service related
	 */
	public static String URL_PSIBLAST_RUN = "http://www.ebi.ac.uk/Tools/services/rest/psiblast/run/";
	public static String URL_PSIBLAST_STATUS = "http://www.ebi.ac.uk/Tools/services/rest/ncbiblast/status/";
	public static String URL_PSIBLAST_RESULTTYPE = "http://www.ebi.ac.uk/Tools/services/rest/ncbiblast/resulttypes/";
	public static String URL_PSIBLAST_RESULT = "http://www.ebi.ac.uk/Tools/services/rest/psiblast/result/";
	public static String URL_PARAM_PSIBLAST = "email=i2no@163.com&psithr=0.001&database=uniprotkb_swissprot";
	public static String PSSM_MATRIX_ACID_ORDER = "ARNDCQEGHILKMFPSTWYV";	// PSSM󰱻ʾ˳򣨺
	
	/**
	 * PsePSSM
	 */
	public static int PSSM_LAMDA_MIN = 1; 	// PsePSSM㷨-LAMDAȡֵΧ-Сֵ
	public static int PSSM_LAMDA_MAX = 10;	// PsePSSM㷨-LAMDAȡֵΧ-ֵ
	
	/**
	 * PsePSSM㷨еķ
	 */
	public static String[] PSEPSSM_COMPOSITION_GROUP = COMPOSITION_GROUP_COLLECTION[4];
	public static String PSEPSSM_COMPOSITION_GROUP_LEADER = COMPOSITION_GROUP_LEADER_COLLECTION[4];
	
	/**
	 * PsePP
	 */
	public static int PSEPP_LAMDA_MIN = 1; 	// PsePP㷨-LAMDAȡֵΧ-Сֵ
	public static int PSEPP_LAMDA_MAX = 10;	// PsePP㷨-LAMDAȡֵΧ-ֵ
	public static int PSEPP_LAMDA_MAX_COLLECTION[] = {1,2,3,4,5,6,7,8,9,10};
	// PsePP㷨ʹõѧԣֵʾnݣ
	public static int PSEPP_PROP_ACTIVE_INDICE[] = { 0,1,2,3,4,5,8,16,18,24	};	
	// ѧԲѯ
	public static double PSEPP_PROP_DATA[] = 
	{
		0.62, 0.29, -0.9, -0.74, 1.19, 0.48, -0.4, 1.38, -1.5, 1.06, 0.64, -0.78, 0.12, -0.85, -2.53, -0.18, -0.05, 1.08, 0.81, 0.26,	// * Hydrophobicity // 0
		27.8,15.5,60.6,68.2,25.5,24.5,50.7,22.8,103.0,27.6,33.5,60.1,51.5,68.7,94.7,42.0,45.0,23.7,34.7,55.2,	// * Average accessible surface area // 1
		0.357,0.346,0.511,0.497,0.314,0.544,0.323,0.462,0.466,0.365,0.295,0.463,0.509,0.493,0.529,0.507,0.444,0.386,0.305,0.420,	// * Average flexibility indices // 2
		0,0,-1,-1,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,	// * Net charge (Klein et al., 1984) // 3
		-0.5, -1, 3, 3, -2.5, 0, -0.5, -1.8, 3, -1.8, -1.3, 0.2, 0, 0.2, 3, 0.3, -0.4, -1.5, -3.4, -2.3,		// * Hydrophilicity // 4
		15, 47, 59, 73, 91, 1, 82, 57, 73, 57, 75, 58, 42, 72, 101, 31, 45, 43, 130, 107,			// * Mass // 5
		4.34,35.77,12.00,17.26,29.40,0.00,21.81,19.06,21.29,18.78,21.64,13.28,10.93,17.56,26.66,6.35,11.01,13.92,42.53,31.53,	// refractivity // 6
		297,178,270,249,284,290,277,284,224,337,283,236,222,185,238,228,253,293,282,344,	// Melting point // 7
		27.5,44.6,40.0,62.0,115.5,0.0,79.0,93.5,100.0,93.5,94.1,58.7,41.9,80.7,105.0,29.3,51.3,71.5,145.5,117.3,	// * Side chain volume (Krigbaum-Komoriya, 1979) // 8
		0.616,0.680,0.028,0.043,1.000,0.501,0.165,0.943,0.283,0.943,0.738,0.236,0.711,0.251,0.000,0.359,0.450,0.825,0.878,0.880,	// Scaled side chain hydrophobicity values // 9
		0.83,1.19,0.54,0.37,1.38,0.75,0.87,1.60,0.74,1.30,1.05,0.89,0.55,1.10,0.93,0.75,1.19,1.70,1.37,1.47,	// Normalized frequency of beta-sheet // 10
		1.42,0.70,1.01,1.51,1.13,0.57,1.00,1.08,1.16,1.21,1.45,0.67,0.57,1.11,0.98,0.77,0.83,1.06,1.08,0.69,	// Normalized frequency of alpha-helix // 11
		1.56,1.23,0.14,0.23,2.03,0.62,0.29,1.67,0.15,2.93,2.96,0.27,0.76,0.51,0.45,0.81,0.91,1.14,1.08,0.68,	// Membrane-buried preference parameters // 12
		7.3,-9.2,-2.9,-7.1,19.2,-1.2,-2.1,6.6,-3.7,20.0,5.6,-5.7,5.1,-0.3,-3.6,-4.1,0.8,3.5,16.3,5.9,	// Retention coefficient in TFA // 13
		0.52,0.62,0.76,0.68,0.70,0.00,0.70,1.02,0.68,0.98,0.78,0.76,0.36,0.68,0.68,0.53,0.50,0.76,0.70,0.70,	// Steric parameter // 14
		1.80,-16.50,5.05,12.00,-34.50,0.00,-38.50,12.40,14.60,-11.00,-10.00,-5.60,-86.20,6.30,12.50,-7.50,-28.00,5.63,-33.70,-10.00, // Optical rotation // 15
		8.1,5.5,13.0,12.3,5.2,9.0,10.4,5.2,11.3,4.9,5.7,11.6,8.0,10.5,10.5,9.2,8.6,5.9,5.4,6.2,	// * Polarity // 16
		29.22,50.70,37.09,41.84,48.52,23.71,59.64,45.00,57.10,48.03,69.32,38.30,36.13,44.02,26.37,32.40,35.20,40.35,56.92,51.73,	// Heat capacity // 17
		6.00,5.05,2.77,3.22,5.48,5.97,7.59,6.02,9.74,5.98,5.74,5.41,6.30,5.65,10.76,5.68,5.66,5.96,5.89,5.66,	// * Isoelectric point // 18
		1.18,1.89,0.05,0.11,1.96,0.49,0.31,1.45,0.06,3.23,2.67,0.23,0.76,0.72,0.20,0.97,0.84,1.08,0.77,0.39,	// Signal sequence helical potential // 19
		-0.20,-0.45,-0.20,-0.30,-2.33,0.00,-0.12,-2.26,-0.35,-2.46,-1.47,0.08,-0.98,0.16,-0.12,-0.39,-0.52,-1.56,-2.01,-2.24,	// Transfer free energy to surface // 20
		1.26,1.60,0.27,0.23,1.46,1.08,1,1.44,0.33,1.36,1.52,0.59,0.54,0.39,0.38,0.98,1.01,1.33,1.06,0.89,	// Average membrane preference: AMP07 (Degli Esposti et al., 1990) // 21
		13.4,22.6,8.2,7.3,23.9,7.0,11.3,20.3,6.1,20.8,15.7,7.6,9.9,8.5,8.5,8.2,10.3,19.5,24.5,19.5,	// Buriability (Zhou-Zhou, 2004) // 22
		0,0,0,1.27,0,0,1.45,0,3.67,0,0,0,0,1.25,2.45,0,0,0,6.93,5.06,	// Amphiphilicity index (Mitaku et al., 2002) // 23
		89.09,121.15,133.10,147.13,165.19,75.07,155.16,131.17,146.19,131.17,149.21,132.12,115.13,146.15,174.20,105.09,119.12,117.15,204.24,181.19	// * Molecular weight // 24
	};
	
	/**
	 * PRTC-38 Composition
	 */
	public static String PRTC_38_COMPOSITION[] = {
		"V", "T", "A", "H", "K", "E", "R", "S", "LE", "VT", "VG", 
		"MK", "TA", "TS", "AT", "HI", "KL", "KI", "KH", "KN", "KK", 
		"KD", "KE", "KW", "KR", "DK", "EF", "EL", "EV", "EK", "EE", 
		"EW", "CE", "WK", "RE", "SG", "GV", "GG"
	};
	
	/**
	 * PRTC-gGap
	 */
	public static char PRTC_GGAP_DELIMITER = '_';
	public static int PRTC_GGAP_GAP_MIN = 0; 	// gGap㷨-gapȡֵΧ-Сֵ
	public static int PRTC_GGAP_GAP_MAX = 9;	// gGap㷨-gapȡֵΧ-ֵ
	
	/**
	 * WEKA Classifiers
	 */
	public static String[] WEKA_CLASSIFIERS_CLASS_NAMES = {
//		"weka.classifiers.bayes.BayesNet",
//		"weka.classifiers.bayes.NaiveBayes",
//		"wlsvm.WLSVM",
//		"weka.classifiers.functions.Logistic",
//		"weka.classifiers.functions.RBFNetwork",
//		"weka.classifiers.rules.DecisionTable",
//		"weka.classifiers.trees.J48",
		"weka.classifiers.trees.RandomForest",
//		"weka.classifiers.functions.SMO",
//		"weka.classifiers.functions.MultilayerPerceptron",
	};
	
	
	/*
	 * 43 Composition
	 * Identification of Antioxidants from Sequence Information Using
		Naive Bayes
	 */
	public static String PRTC_43_COMPOSITION[] = { "C", "G", "FP", "FW", "LK",
			"LS", "IE", "VL", "VH", "VC", "VW", "MS", "PD", "AP", "AY", "YQ",
			"YE", "YR", "HE", "HG", "QA", "KA", "KH", "DF", "DK", "DR", "EF",
			"EM", "EY", "ER", "CP", "CN", "CG", "WC", "RT", "RD", "RW", "SV",
			"SD", "GV", "GY", "GK", "GC" };
	
	
	/**
	 * Replication鶨弯
	 */
	public static String[][] REPLICATION_COMPOSITION_GROUP_COLLECTION = {
		{"G", "IVFYW", "ALMEQRK", "P", "NDHSTC"},
		{"G", "IV", "FYW", "ALM", "EQRK", "P", "ND", "HSTC"},
		{"G", "IV", "FYW", "ALM", "EQRK", "P", "ND", "HS", "TC"},
		{"G", "IV", "FYW", "A", "LM", "EQRK", "P", "ND", "HS", "T", "C"},
		{"G", "IV", "FYW", "A", "L", "M", "E", "QRK", "P", "ND", "HS", "T", "C"},
	};
	
	public static String[] REPLICATION_COMPOSITION_GROUP_LEADER_COLLECTION = {
		"GIAPN",
		"GIFAEPNH",
		"GIFAEPNHT",
		"GIFALEPNHTC",
		"GIFALMEQPNHTC",
	};
	
}
